(***************************************************************************)
(**                              UNIT BOXHELP                             **)
(***************************************************************************)
(** Routinen fr die Mailbox Online-Hilfe. Eigene Routine, damit bei      **)
(** einem Aufruf der Hilfe nicht eine komplette Utility-Unit aus dem      **)
(** Overlay geladen werden mu, und damit ich ein bischen bersicht       **)
(** behalte.                                                              **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT BOXHELP;

INTERFACE

(*
 *  PROCEDURE Hilfe_CMD
 * Ruft die MCuT-Online-Hilfe auf.
 *)
PROCEDURE Hilfe_CMD(ch: BYTE; S: STRING);


IMPLEMENTATION


USES BOXVARS,TOOLBOX,IADVAR;

(*
 *  PROCEDURE Hilfe_CMD
 * Ruft die MCuT-Online-Hilfe auf.
 *)
PROCEDURE Hilfe_CMD(ch: BYTE; S: STRING);
VAR tmp,use_this: pOnlineHelp;
    OK,Found: BOOLEAN;
    f: Text;
BEGIN
  IF S[LENGTH(S)]=#13 THEN S := COPY(S,1,LENGTH(S)-1);

  {Filename aus der Liste holen (anhand des bergebenen Befehls)}
  S := LTRIM(RTRIM(Gross(OnlyOneSpace(S))));

  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := 'HELP';

  tmp := OnlineHelp;
  Found := FALSE;
  OK := FALSE;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF COPY(tmp^.Command,1,LENGTH(S))=S THEN BEGIN
      OK := TRUE;
      IF tmp^.Command=S THEN Found := TRUE;
      use_this := tmp;
    END;
    tmp := tmp^.next;
  END;

  IF NOT OK THEN BEGIN
    PutData(ch,#13'Kein Helpfile fr Befehl '+S+' gefunden.'#13#13);
    Exit;
  END;

  IF use_this^.Level>KS[ch]^.Lev THEN BEGIN
    PutData(ch,#13'Kein Helpfile fr Befehl '+S+' gefunden.'#13#13);
    Exit;
  END;

  ASSIGN(f,BoxPath+'HELP\'+use_this^.Filename+'.'+KS[ch]^.BoxData^.Spk);
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    PutData(ch,#13'Kein Helpfile fr Befehl '+S+' gefunden.'#13#13);
    Exit;
  END;

  WHILE NOT EOF(f) DO BEGIN
    READLN(f,S);
    PutData(ch,S+#13);
  END;
  CLOSE(f);
END;



END.