(***************************************************************************)
(**                             unit BOXSF.PAS                            **)
(***************************************************************************)
(**  Routinen fr das W0RLI-S&F und die Eintrge in die SFLISTE.          **)
(**  Nicht frs Overlay bestimmt.                                         **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
{Routinen fr das S&F (nicht frs Overlay bestimmt)}
UNIT BOXSF;


INTERFACE

USES BOXVARS,DOS,BOXUTIL,TOOLBOX,
     BOXHUSER,IADVAR,WGTCRC,CRT;

PROCEDURE MakeEintrag(VAR Info: Verwalt_Rec;VAR ForwList: STRING;Call: str6; Typ: CHAR; LT_Angeg: BOOLEAN;VAR EtrFnd: BOOLEAN;
                      VAR Hierach: STRING; Hold: BOOLEAN);

{IAD,9.12: das flag "nurtest" bewirkt, da lediglich "RoutingTo" gefllt wird,
 aber keine Eintrge gemacht werden}
PROCEDURE AddSFListe(SendCall: str12; Info: Verwalt_Rec; Typ: CHAR; LT_Angeg: BOOLEAN; Hierach: STRING; Hold: BOOLEAN;
                    nurtest:BOOLEAN);
PROCEDURE CheckSID(ch: BYTE; S: STRING);
FUNCTION SendFileDa(Call: str6; ForwWhat: CHAR; ForwSize: WORD): BOOLEAN;
PROCEDURE DieBox_SF(ch: BYTE; S: STRING);
PROCEDURE SFConnectDID(ch: BYTE; S: STRING);
PROCEDURE AddForwardMarker(Call: STRING; FileName: STRING);
PROCEDURE GetWhatToForwardList(ch: BYTE; VAR What: CHAR; VAR Size: WORD);
PROCEDURE DelSFFileEntry(BID: str12; Call: str6);

{Diese Variable enthlt nach einem AddSFListe-Aufruf die Boxen, an die die Mail
 geroutet wird}
VAR RoutingTo:STRING;

IMPLEMENTATION

USES
     BOXHOLD,{$IFNDEF LINUX}MEMORY,{$ENDIF}BOXSERV;

PROCEDURE WriteForwListToFile(ForwList: STRING; VAR FileName: STRING);
VAR f: FILE;
    Hlp: ARRAY[1..255] OF CHAR;
    i: BYTE;
BEGIN
  ASSIGN(f,BoxPath+FileName);
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult<>0 THEN Exit;

  FOR i := 1 TO LENGTH(ForwList) DO Hlp[i] := ForwList[i];
  FOR i := LENGTH(ForwList)+1 TO 255 DO Hlp[i] := ' ';

  SEEK(f,257);
  BLOCKWRITE(f,Hlp,255);
  CLOSE(f);
END;



PROCEDURE AddForwardMarker(Call: STRING; FileName: STRING);
VAR f: FILE;
    Hlp: ARRAY[1..255] OF CHAR;
    i: BYTE;
    S: STRING;
    Stelle: BYTE;
    Zeichen: CHAR;
BEGIN
  ASSIGN(f,FileName);
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult<>0 THEN Exit;

  SEEK(f,257);
  BLOCKREAD(f,Hlp,255);
  SEEK(f,257);

  S := '';
  FOR i := 1 TO 255 DO S[i] := Hlp[i];
  S[0] := #255;
  S := RTRIM(S);

  Stelle := POS(' '+Call,S);
  Zeichen := S[Stelle+1+LENGTH(Call)];
  IF (Stelle > 0) AND (Ord(Zeichen)>Ord('Z')) OR (Ord(Zeichen)<Ord('A')) THEN BEGIN
    S[Stelle] := '*';

    FOR i := 1 TO LENGTH(S) DO Hlp[i] := S[i];
    FOR i := LENGTH(S)+1 TO 255 DO Hlp[i] := ' ';

    BLOCKWRITE(f,Hlp,255);
  END;
  CLOSE(f);
END;




{Eintrag in SFLISTE machen}
PROCEDURE MakeEintrag(VAR Info: Verwalt_Rec;VAR ForwList: STRING;Call: str6; Typ: CHAR; LT_Angeg: BOOLEAN;VAR EtrFnd: BOOLEAN;
                      VAR Hierach: STRING; Hold: BOOLEAN);
VAR SFFile: FILE OF SF_File_Rec;
    SFDS: SF_File_Rec;
BEGIN

  {Erstmal die Zeile, die ins File geschrieben wird, erweitern}
  IF LENGTH(ForwList)>0 THEN ForwList := ForwList + '   ' + Call
                        ELSE ForwList := ' ' + Call;

  ASSIGN(SFFile,BoxPath+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult = 0 THEN SEEK(SFFile,FILESIZE(SFFile))
                  ELSE REWRITE(SFFile);

  SFDS.SF_Partner := Gross(Call);
  SFDS.Von := Info.Absender;
  SFDS.An := Info.Rubrik;
  SFDS.Via := Info.MBX;
  SFDS.LT := Info.LifeTime;
  SFDS.Titel := Info.Titel;
  SFDS.FileName := Info.FileName;
  SFDS.Hierachie := Hierach;

  {Reihenfolge des Forwards dieses Files}
  IF SFDS.An = 'F' THEN SFDS.Prio := 1
  ELSE BEGIN {Keine F-Mail}
    IF Rufz(SFDS.An) THEN SFDS.Prio := 10
    ELSE BEGIN       {Kein Userfile}
      IF (SFDS.An <> 'E') AND (SFDS.An <> 'M') THEN SFDS.Prio := 20
                                               ELSE SFDS.Prio := 30;
    END;
  END;

  {Art der Mail (U, B, G, A, M, E)
    U = User-Mail
    B = Bulletin (ffentlich)
    G = Group-Forward
    A = Acknowledge-Mail
    M = MYBBS-Fowarding
    E = Erase-Forwarding
  }
  IF Typ = 'P' THEN SFDS.Art := 'P'
  ELSE BEGIN
    IF Gross(SFDS.An) = 'M' THEN SFDS.Art := 'M'
    ELSE BEGIN
      IF Gross(SFDS.An) = 'E' THEN SFDS.Art := 'E'
      ELSE BEGIN
        IF Typ = 'A' THEN SFDS.Art := 'A'
        ELSE BEGIN
          IF Rufz(SFDS.An) THEN SFDS.Art := 'P'
          ELSE BEGIN
            IF SFDS.An[1] = '*' THEN SFDS.Art := 'G'
                                ELSE SFDS.Art := 'B';
          END;
        END;
      END;
    END;
  END;

  SFDS.BID := Info.BID;
  SFDS.Groesse := Info.Groesse;

  {Flags - Siehe BOXVARS.PAS}
  SFDS.Flags := 0;           {Alle Flags lschen}
  IF LT_Angeg THEN SFDS.Flags := SFDS.Flags OR SFLISTE_LTMIT;   {Lifetime}
  IF Hold THEN SFDS.Flags := SFDS.Flags OR SFLISTE_HOLD;        {Hold}

  WRITE(SFFile,SFDS);
  CLOSE(SFFile);
  EtrFnd := TRUE;
END;



PROCEDURE AddSFListe(SendCall: str12; Info: Verwalt_Rec; Typ: CHAR; LT_Angeg: BOOLEAN; Hierach: STRING; Hold: BOOLEAN;
                     nurtest:BOOLEAN);
VAR Hlp,S,Hlp1: STRING;
    Unt_Hierach: STRING[40];
    OK, Any_Eintrag,EintragFound: BOOLEAN;
    BBSCall: str6;
    Eintrag: BOOLEAN;   {TRUE, wenn die Mail beim aktuellen Call eingetragen
                         wird}
    i: WORD;
    Negative: BOOLEAN;  {Files aus forward wieder austragen?}
    ForwList: STRING;
    EintragHierachie: STRING;   {Hierachie, die letztenendlich in SFLISTE
                                 geschrieben wird}
    tmp: pBoxSF;

BEGIN

 RoutingTo:='';
  {Wenn die Mail fr mich ist wird sie nicht weiter geforwardet. (logisch)
   Hierdurch sollten Usermails auch nichtmehr zum Atari zurck geforwardet
   werden!}
  IF Gross(Info.MBX)=Gross(CutSSID(BoxCall)) THEN BEGIN
    {Wenn die Mail an die eigene Mailbox geht, wird kontrolliert, ob
     hier ein MYBBS-Eintrag vorhanden ist, der woanders hin zeigt.
     Ist dies der fall, wird der Verteiler auf diese Box gesetzt.}

    IF NOT Rufz(Info.Rubrik) THEN Exit;       {keine Usermails -> fertig}
    Hlp := GetMYBBS(Info.Rubrik);
    IF Hlp='' THEN Exit;        {Kein MYBBS-Eintrag vorhanden -> fertig}
    IF Hlp=CutSSID(BoxCall) THEN Exit;  {MYBBS-Eintrag stimmt mit dieser
                                         Box berein -> fertig}

    {Sooo... Der MYBBS-Eintrag steht nicht auf diese Box. Das MBX-Feld
     wird umgeschrieben, so da die Mail an die Mailbox geht, die im
     Userfile als MYBBS fr diesen Partner eingetragen ist. Ausserdem bekommt die
     Mail ein neues BID}
    Info.MBX := Hlp;
    hlp:=Info.BID;
    Info.BID := Neu_BID;
    ProfileBox('P-Mail redirected, old BID:'+hlp+', new:'+Info.BID,PBOX_REDIRECT);
  END;
  if (typ='P') and (not rufz(info.mbx)) THEN
    ProfileBox('P-Mail @MBX: $'+info.bid+' '+info.rubrik+'@'+info.mbx+' <'+info.absender,PBOX_ROUTINGERROR);

  EintragHierachie := Hierach;

  {Variablen initialisieren}
  Any_Eintrag := FALSE;
  EintragFound := FALSE;
  ForwList := '';
  tmp := BoxSFRoot;     {Start der S&F-Definitionen im RAM}
  WHILE tmp<>NIL DO BEGIN
    IF (tmp^.Call<>SendCall) THEN BEGIN
     {Nichts an die Station
      forwarden, von der wir den Text bekommen haben}

      BBSCall := tmp^.Call;
      Eintrag := FALSE;
      Negative := FALSE;
      S := tmp^.WhatToForward;

      REPEAT
        {Zeile zerflcken}
        IF POS(' ',S)>0 THEN BEGIN
          Hlp := COPY(S,1,POS(' ',S)-1);
          S := COPY(S,POS(' ',S)+1,255);
        END
        ELSE BEGIN
          Hlp := S;
          S := '';
        END;

        IF Info.MBX=BBSCall THEN
        BEGIN
          Eintrag := TRUE;
          Any_Eintrag:=TRUE;
        END
        ELSE
        CASE Hlp[1] OF
          '@': IF Match(Info.MBX,COPY(Hlp,2,255)) THEN BEGIN
                 IF Negative THEN Eintrag := FALSE
                             ELSE Eintrag := TRUE;
                 Any_Eintrag := TRUE;
               END;
          '&': IF Match(Info.Rubrik,COPY(Hlp,2,255)) THEN BEGIN
                 IF Negative THEN Eintrag := FALSE
                             ELSE Eintrag := TRUE;
                 Any_Eintrag := TRUE;
               END;
          '<': IF Match(Info.Absender,COPY(Hlp,2,255)) THEN BEGIN
                 IF Negative THEN Eintrag := FALSE
                             ELSE Eintrag := TRUE;
                 Any_Eintrag := TRUE;
               END;
          '|': Negative := NOT Negative;
        END;
      UNTIL S='';

      IF Eintrag THEN BEGIN
        RoutingTo:=RoutingTo+BBScall+' ';
        {Mail wird bei dieser Station eingetragen, der eintrag LOCAL dient dazu,
        da kein routing-error erzeugt wird, wenn eine Nachricht von einem S&F-Partner
        empfangen wird, deren Verteiler nur bei diesem einem s&f partner eingetragen ist.
        Normalerweise wrde dann ein Routingerror gemeldet, weil die Mail nirgends zum S&F
        eingetragen wrde...}
        IF (BBSCALL<>'LOCAL') and not nurtest THEN
        MakeEintrag(Info,ForwList,BBSCall,Typ,LT_Angeg,EintragFound,EintragHierachie,Hold);
      END;

    END;
    {Wenn die mail eine p-mail ist oder das ziel eine mailbox}
    IF eintrag AND ((typ='P') OR (rufz(info.mbx))) THEN
      tmp:=NIL ELSE
      tmp := tmp^.next;
  END;
  IF NOT EintragFound AND NOT Any_Eintrag THEN BEGIN
  {Funktioniert nur bei Mails, die an eine Mailbox adressiert ist
   (kein Verteiler)}
    IF Rufz(Info.MBX) THEN BEGIN
      S := FastSFPartner(Info.MBX);
      IF (S <> '') or (S<>cutssid(boxcall)) THEN BEGIN        {Es ist auch noch S&F-Partner auf
                                    unserer Seite bekannt}
        Eintrag := FALSE;
        tmp := BoxSFRoot;
        WHILE (tmp<>NIL) AND NOT Eintrag DO BEGIN
          IF tmp^.Call=S THEN Eintrag := TRUE
                         ELSE tmp := tmp^.next;
        END;
        IF Eintrag THEN BEGIN
          {Im Autorouter gefunden - Eintragen}
          RoutingTo:=RoutingTo+tmp^.call+' ';
          IF not nurtest THEN
          MakeEintrag(Info,ForwList,tmp^.Call,'P',LT_Angeg,EintragFound,EintragHierachie,Hold)
        END;
      END
      ELSE IF NOT Eintrag THEN BEGIN
        {Nicht gefunden -> Hierachisches Forward}
        IF LENGTH(Hierach)>0 THEN BEGIN
          Hierach := LTRIM(RTRIM(Hierach));
          S := OwnBoxData^.Hierach;

          {Erstmal den kleinsten gemeinsamen Nenner finden (erstes
           H-Feld, das nicht gleich ist (von rechts aus)}
          REPEAT
            i := LENGTH(Hierach);
            WHILE Hierach[i]<>'.' DO dec(i);
            Hlp := COPY(Hierach,i+1,255);
            Hierach := COPY(Hierach,1,i-1);

            i := LENGTH(S);
            Hlp1 := S;
            WHILE Hlp1[i]<>'.' DO dec(i);
            Hlp1 := COPY(Hlp1,i+1,255);
            S := COPY(S,1,i-1);
          UNTIL (Hlp<>Hlp1) OR ((Hlp='') AND (Hlp1=''));
          {So, in Hlp steht jetzt das erste anderslautende H-Feld drin.}

          IF (LENGTH(S)>0) AND (LENGTH(Hlp)>0) THEN BEGIN
            {jetzt wird der Eintrag gesucht... da nur an Mailboxen
             hierachisch geoforwardet wird, kann nach dem ersten finden
             abgebrochen werden.}

            Unt_Hierach := Gross(Hlp);  {erste unterschiedliche Hierache
                                         nach Unt_Hierach}

            tmp := BoxSFRoot;
            OK := FALSE;
            WHILE (tmp<>NIL) AND NOT OK DO BEGIN
              IF tmp^.Call<>SendCall THEN BEGIN
                BBSCall := Hlp;
                S := tmp^.WhatToForward;

                REPEAT
                  {Zeile zerflcken}
                  IF POS(' ',S)>0 THEN BEGIN
                    Hlp := COPY(S,1,POS(' ',S)-1);
                    S := COPY(S,POS(' ',S)+1,255);
                  END
                  ELSE BEGIN
                    Hlp := S;
                    S := '';
                  END;

                  IF Hlp='.'+Unt_Hierach THEN OK := TRUE;

                UNTIL (S='') OR OK;

                IF OK THEN BEGIN
                  ForwList := '';
                  eintrag:=TRUE;
                  RoutingTo:=RoutingTo+tmp^.call+' ';
                  IF not nurtest THEN
                  MakeEintrag(Info,ForwList,tmp^.Call,Typ,LT_Angeg,EintragFound,EintragHierachie,Hold);
                END;

              END;
              tmp := tmp^.next;
            END;
          END;
        END;
      END;
    END;
  END;
  IF not nurtest THEN
  BEGIN
    IF LENGTH(ForwList)>0 THEN WriteForwListToFile(ForwList,Info.FileName);
    IF routingto='' THEN
      ProfileBox('Routing error: $'+info.bid+' '+info.rubrik+'@'+info.mbx+' <'+info.absender,PBOX_ROUTINGERROR);
  END;
END;


{Wir wurden Connected}
PROCEDURE CheckSID(ch: BYTE; S: STRING);
VAR i,Use_SID: BYTE;
    Hlp: STRING;
    FreeSpace: LONGINT;
BEGIN
  {Erstmal gucken, ob genug speicher vorhanden ist.}
  FreeSpace := DiskFree(Ord(Upcase(BoxPath[1]))-64);
  FreeSpace := FreeSpace DIV 1024;
  {Wenn zu wenig frei ist, diese Routine verlassen.}
  IF FreeSpace<OwnBoxData^.SF_Ab_kBytes THEN BEGIN
    PutData(ch,'*** not enough hard disk space free');
    KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
    Exit;
  END;




  {Kontrolle, welche SID benutzt werden soll}
  Use_SID := What_SID(CutSSID(KS[ch]^.Call));

  {Gucken, ob das verkrzte DieBox-Format fr E und M-Mails verwendet
   wird}
  Hlp := COPY(S,POS('[',S)+1,255);
  Hlp := Gross(COPY(Hlp,1,POS('-',Hlp)-1));
  {
  IF (Hlp='THEBOX') OR (Hlp='BAYCOM') THEN KS[ch]^.DBSFData^.TheBox_E_M_Format := TRUE
                                      ELSE KS[ch]^.DBSFData^.TheBox_E_M_Format := FALSE;
   
  IF Use_SID<>2 THEN KS[ch]^.DBSFData^.TheBox_E_M_Format := FALSE;
  KS[ch]^.DBSFData^.SchmeissWech:=FALSE;
}
  {Kontrolle einer evtl. vorhandenen Passwort-Antwort}
  IF KS[ch]^.BoxData^.SF_PW THEN BEGIN
    Hlp := S;
    WHILE POS(' ',Hlp)>0 DO Hlp := COPY(Hlp,POS(' ',Hlp)+1,255);
    Hlp := LTRIM(RTRIM(Hlp));

    {So, die Antwort (Passwort) steht jetzt in Hlp}
    IF POS(KS[ch]^.BoxData^.SF_PW_What,HLP)=0 THEN BEGIN
      PutData(ch,'*** Wrong password'+#13);
      ProfileBox('S&F-PW Fail: '+cutssid(KS[ch]^.call)+' expected:'+KS[ch]^.BoxData^.SF_PW_What+
       ', received:'+hlp,PBOX_SFPWFAIL);
      KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
      Exit;
    END;
  END;


  IF POS('[',S) > 0 THEN DELETE(S,POS('[',S),1);
  IF POS(']',S) > 0 THEN DELETE(S,POS(']',S),1);

  WHILE POS('-',S)>0 DO S := COPY(S,POS('-',S)+1,255);


  {Untersttzt die Gegenseite S&F nach F6FBB?}
  IF (POS('F',S) > 0) AND (Use_SID=1) THEN BEGIN
    NEW(KS[ch]^.FBBSFData);
    {Gucken, ob die Station nicht in BOX.SF steht. (Sonst darf sie ja
     s&f machen etc)}
    IF NOT KS[ch]^.BoxData^.Start_SF THEN BEGIN
      KS[ch]^.FBBSFData^.BOXSF_Partner := FALSE;
      {Drfen Stationen, die nicht in BOX.SF stehen, berhaupt S&F mit uns
       machen?}
      IF NOT OwnBoxData^.SF_mit_jedem THEN BEGIN
        {n}
        PutData(ch,#13'*** You are not allowed to login as a S&F-Mailbox.'#13#13);
        KS[ch]^.Flags := KS[ch]^.Flags OR KS_DISCREQ;
        Exit;
      END;
    END
    ELSE KS[ch]^.FBBSFData^.BOXSF_Partner := TRUE;

    IF KS[ch]^.BoxData^.SF_PW THEN KS[ch]^.FBBSFData^.PW_Gesichert := TRUE
                              ELSE KS[ch]^.FBBSFData^.PW_Gesichert := FALSE;
    DISPOSE(KS[ch]^.BoxData);
    KS[ch]^.BoxData := NIL;

    KS[ch]^.status := 52;       {FBB-S&F}
    KS[ch]^.FBBSFData^.status := 0;      {Auf Proposal warten}
    KS[ch]^.FBBSFData^.AnzProposal := 0; {Noch ein Proposal empfangen}
    KS[ch]^.FBBSFData^.ChckSum := 0;     {Checksumme mit 0 vorladen}
    KS[ch]^.FBBSFData^.Chck16 := 0;      {16-BIT-Checksumme ebenfalls mit 0
                                          vorladen}
    KS[ch]^.FBBSFData^.Temp := '';
{    KS[ch]^.FBBSFData^.GetCRC := FALSE;}
    GetWhatToForwardList(ch,KS[ch]^.FBBSFData^.ForwWhat,KS[ch]^.FBBSFData^.ForwSize);


    WITH KS[ch]^.FBBSFData^.Features DO BEGIN
      A := FALSE;
      M := FALSE;
      G := FALSE;
      H := FALSE;
      D := FALSE;
      B := FALSE;
      B_Lev := 0;
      R := FALSE;
      FOR i := 1 TO LENGTH(S) DO BEGIN
        CASE S[i] OF
          'A': A := TRUE;
          'M': M := TRUE;
          'G': G := TRUE;
          'H': H := TRUE;
          'D': D := TRUE;
          'B': B := TRUE;
{$IFDEF B1}
          'R': R := TRUE;
          '1': IF S[i-1]='B' THEN B_Lev := 1;
{$ENDIF}
        END;
      END;
    END;
    {Bei FBB wird nach der SID KEIN(!) Prompt ausgesendet!
     einfach auf den Proposal (Liste der zu empfangenen (vielleicht, hi)
     mails) warten}

  END
  ELSE BEGIN
    NEW(KS[ch]^.DBSFData);
    {Gucken, ob die Station nicht in BOX.SF steht. (Sonst darf sie ja
     s&f machen etc)}
    IF NOT KS[ch]^.BoxData^.Start_SF THEN BEGIN
      KS[ch]^.DBSFData^.BOXSF_Partner := FALSE;
      {Drfen Stationen, die nicht in BOX.SF stehen, berhaupt S&F mit uns
       machen?}
      IF NOT OwnBoxData^.SF_mit_jedem THEN BEGIN
        {n}
        PutData(ch,#13'*** You are not allowed to login as a S&F-Mailbox.'#13#13);
        KS[ch]^.Flags := KS[ch]^.Flags OR KS_DISCREQ;
        Exit;
      END;
    END
    ELSE KS[ch]^.DBSFData^.BOXSF_Partner := TRUE;


    IF KS[ch]^.BoxData^.SF_PW THEN KS[ch]^.DBSFData^.PW_Gesichert := TRUE
                              ELSE KS[ch]^.DBSFData^.PW_Gesichert := FALSE;
    DISPOSE(KS[ch]^.BoxData);
    KS[ch]^.BoxData := NIL;

    KS[ch]^.status := 51;       {RLI-S&F}
    KS[ch]^.DBSFData^.status := 0;
    KS[ch]^.DBSFData^.F_Get := FALSE;
    KS[ch]^.DBSFData^.SchmeissWech:=FALSE;
    GetWhatToForwardList(ch,KS[ch]^.DBSFData^.ForwWhat,KS[ch]^.DBSFData^.ForwSize);


    WITH KS[ch]^.DBSFData^.Features DO BEGIN
      A := FALSE;
      M := FALSE;
      G := FALSE;
      H := FALSE;
      D := FALSE;
      B := FALSE;
      B_Lev := 0;
      R := FALSE;
      FOR i := 1 TO LENGTH(S) DO BEGIN
        CASE S[i] OF
          'A': A := TRUE;
          'M': M := TRUE;
          'G': G := TRUE;
          'H': H := TRUE;
          'D': D := TRUE;
          'B': B := TRUE;
{$IFDEF B1}
          'R': R := TRUE;
          '1': IF S[i-1]='B' THEN B_Lev := 1;
{$ENDIF}
        END;
      END;
    END;
    PutData(ch,'>'+#13);
  END;

END;




PROCEDURE CheckDBSendLine(ch: BYTE; S: STRING);
VAR Hlp: STRING;
    code: WORD;
    OK,OK2: BOOLEAN;
    f: Text;
    B,B1:BYTE;
BEGIN
  S := OnlyOneSpace(S);
  IF upcase(s[1])<>'S' THEN
  BEGIN
    PutData(ch,'*** error'+#13);
    KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
    exit;
  END;
  KS[ch]^.DBSFData^.BID := '';
  KS[ch]^.DBSFData^.Send_To := '';
  KS[ch]^.DBSFData^.Send_From := '';
  KS[ch]^.DBSFData^.Send_Via := '';
  KS[ch]^.DBSFData^.Titel := '';
  KS[ch]^.DBSFData^.LT := -1;
  KS[ch]^.DBSFData^.SFPartner := '';
  KS[ch]^.DBSFData^.AuswertHeader := TRUE;
  KS[ch]^.DBSFData^.LT_Angegeben := FALSE;

  KS[ch]^.DBSFData^.SchmeissWech:=TRUE;
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);


  {Gucken, ob CTRL-Z in der Send-Zeile steht... wenn ja wird wohl das
   verkrzte DieBox-Format fr E und M-Mails verwendet.}
  IF POS(#26,S)>0 THEN BEGIN
    S := COPY(S,POS(' ',S)+1,255);

    IF S[1]='M' THEN BEGIN
      {M-Mail speichern}
      Hlp := 'SB M @ ';
      S := LTRIM(RTRIM(COPY(S,POS('@',S)+1,255)));
      Hlp := Hlp + COPY(S,1,POS(' ',S)-1)+' < ';
      S := LTRIM(RTRIM(COPY(S,POS('<',S)+1,255)));
      Hlp := Hlp + COPY(S,1,POS(' ',S)-1)+' $';
      S := COPY(S,POS('$',S)+1,255);
      Hlp := Hlp + COPY(S,1,POS(' ',S)-1);
      S := COPY(S,POS(' ',S)+1,255);
      DELETE(S,POS(#26,S),1);
      S := LTRIM(RTRIM(S));

      ASSIGN(f,BoxPath+'import'+PATH_SEP+FindUniqueImportFilename);
      {$I-}
      REWRITE(f);
      {$I+}
      IF IOResult<>0 THEN Exit;
      WRITELN(f,Hlp); {Send-Zeile speichern}
      WRITELN(f,S);   {Als Titel die Mailbox und die Unix-Zeit sichern}
      CLOSE(f);       {Das wars}
      PutData(ch,'>'+#13);
    END

    ELSE BEGIN
      {E-Mails oder sonstiges mit CTRL-Z in der Send-Zeile.
       Bislang noch nix machen}
    END;

    Exit;
    PutData(ch,'>'+#13);
  END;


  DELETE(S,1,1);        {'S' am Anfang abschneiden}
  CASE S[1] OF
    ' ': KS[ch]^.DBSFData^.Typ := ' ';
    'B': KS[ch]^.DBSFData^.Typ := 'B';
    'P': KS[ch]^.DBSFData^.Typ := 'P';
  END;
  S := COPY(S,POS(' ',S)+1,255);



  IF POS('$',S) > 0 THEN BEGIN  {BID wurde angegeben}
    Hlp := COPY(S,POS('$',S)+1,255);
    IF POS(' ',Hlp) > 0 THEN Hlp := COPY(Hlp,1,POS(' ',Hlp)-1);
    KS[ch]^.DBSFData^.BID := Hlp;
  END
  ELSE S := S + ' $123';

  OK := BID_Da(KS[ch]^.DBSFData^.BID);
  IF OK AND (KS[ch]^.DBSFData^.BID <> '')THEN BEGIN
    PutData(ch,'NO - Already have '+KS[ch]^.DBSFData^.BID+#13+'>'+#13);
    Exit;
  END;
  {Checken, ob das File bereits auf einem anderen Kanal empfangen wird}
  OK:=TRUE;
  FOR B:=1 TO 255 DO BEGIN
    IF (KS[b]<>NIL) AND (KS[b]^.FBBSFData<>NIL) AND OK THEN BEGIN
      FOR B1:=1 to KS[b]^.FBBSFData^.AnzProposal DO BEGIN
        IF OK THEN
           IF (KS[b]^.FBBSFData^.MailDat[B1].BID=KS[ch]^.DBSFData^.BID)
              AND (KS[b]^.FBBSFData^.MailDat[b1].send<>'=')  THEN
                  OK:=FALSE;
      END;
    END
    ELSE IF (KS[b]<>NIL) AND (KS[b]^.DBSFData<>NIL) AND (b<>ch) AND OK THEN
              IF (KS[b]^.DBSFData^.BID=KS[ch]^.DBSFData^.BID) THEN OK:=FALSE;
  END;
  IF NOT OK THEN BEGIN
    PutData(ch,'*** Already receiving '+KS[ch]^.DBSFData^.BID+#13);
    KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
    Exit;
  END;

  IF POS('#',S) > 0 THEN BEGIN    {Lifetime wurde angegeben}
    Hlp := LTRIM(RTRIM(COPY(S,POS('#',S)+1,255)));
    IF POS(' ',Hlp) > 0 THEN Hlp := COPY(Hlp,1,POS(' ',Hlp)-1);
    VAL(Hlp,KS[ch]^.DBSFData^.LT,code);
    IF code <> 0 THEN BEGIN
      KS[ch]^.DBSFData^.LT := -1;
      KS[ch]^.DBSFData^.LT_Angegeben := FALSE;
    END
    ELSE KS[ch]^.DBSFData^.LT_Angegeben := TRUE;
  END;


  IF POS('<',S) = 0 THEN BEGIN
     KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
    Exit;
  END;

  Hlp := LTRIM(RTRIM(COPY(S,POS('<',S)+1,255)));
  IF POS(' ',Hlp) > 0 THEN Hlp := LTRIM(RTRIM(COPY(Hlp,1,POS(' ',Hlp)-1)));
  KS[ch]^.DBSFData^.Send_From := Hlp;

  IF POS('@',S) > 0 THEN BEGIN
    WHILE S[POS('@',S)+1] = #32 DO DELETE(S,POS('@',S)+1,1);
    WHILE S[POS('@',S)-1] = #32 DO DELETE(S,POS('@',S)-1,1);
    S := COPY(S,1,POS(' ',S)-1);
    KS[ch]^.DBSFData^.Send_To := COPY(S,1,POS('@',S)-1);
    S := COPY(S,POS('@',S)+1,255);
    IF POS('.',S) > 0 THEN BEGIN
      KS[ch]^.DBSFData^.Hierach := COPY(S,POS('.',S),255);
      S := COPY(S,1,POS('.',S)-1);
    END
    ELSE KS[ch]^.DBSFData^.Hierach := '';
    KS[ch]^.DBSFData^.Send_Via := S;
  END
  ELSE BEGIN
    KS[ch]^.DBSFData^.Send_To := LTRIM(RTRIM(COPY(S,1,POS('<',S)-1)));
    KS[ch]^.DBSFData^.Send_Via := CutSSID(BoxCall);
  END;

  IF KS[ch]^.DBSFData^.BID = '' THEN KS[ch]^.DBSFData^.BID := Neu_BID;
  KS[ch]^.DBSFData^.BID := Gross(KS[ch]^.DBSFData^.BID);
  KS[ch]^.DBSFData^.Send_To := Gross(KS[ch]^.DBSFData^.Send_To);
  KS[ch]^.DBSFData^.Send_From := Gross(KS[ch]^.DBSFData^.Send_From);
  KS[ch]^.DBSFData^.Send_Via := Gross(KS[ch]^.DBSFData^.Send_Via);

  IF KS[ch]^.DBSFData^.Typ = ' ' THEN BEGIN
    IF Rufz(KS[ch]^.DBSFData^.Send_To) THEN KS[ch]^.DBSFData^.Typ := 'P'
                                       ELSE KS[ch]^.DBSFData^.Typ := 'B';
  END;


  IF NOT OwnBoxData^.Third_Party AND (KS[ch]^.DBSFData^.Send_From<>CutSSID(KS[ch]^.Call))
                                 AND NOT KS[ch]^.DBSFData^.BOXSF_Partner THEN BEGIN
    PutData(ch,'NO - Thirdparty-mail not allowed on this system.'#13'>'#13);
    Exit;
  END;


  PutData(ch,'OK'#13);
  KS[ch]^.DBSFData^.status := 1;

  IF KS[ch]^.DBSFData^.LT = -1 THEN BEGIN
    {Lifetime kontrollieren bzw. setzen}
    IF KS[ch]^.DBSFData^.Typ = 'P' THEN KS[ch]^.DBSFData^.LT := OwnBoxData^.User_LT
    ELSE BEGIN
      code := KS[ch]^.DBSFData^.LT;
      StandardLT(code,KS[ch]^.DBSFData^.Send_To);
      KS[ch]^.DBSFData^.LT := code;
    END;
  END;
END;



PROCEDURE GetDBTitel(ch: BYTE;S: STRING);
VAR
    jetzt: LONGINT;
    DatNam,FileName: STRING;
    aword: WORD;
    Hlp: STRING;
    NeuRubrikName: str8;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  KS[ch]^.DBSFData^.Titel := S;
  KS[ch]^.DBSFData^.status := 2;
  KS[ch]^.DBSFData^.BIN := FALSE;
  KS[ch]^.DBSFData^.SchmeissWech:=FALSE;
  jetzt := CurrIxTime;
  IF jetzt <> LastTime THEN BEGIN
    AnzPerSec := 0;
    LastTime := jetzt;
  END
  ELSE BEGIN
    AnzPerSec := AnzPerSec + 1;
  END;
  DatNam := klein(XHex(jetzt));
{  jetzt := jetzt - 700000000;
  STR(jetzt,DatNam);}
  STR(AnzPerSec,FileName);
  DatNam := DatNam + '.' + FileName;

  FileName := BoxPath;
  IF KS[ch]^.DBSFData^.Typ = 'P' THEN FileName := BoxPath + 'user'+PATH_SEP
                                 ELSE FileName := BoxPath + 'info'+PATH_SEP;

  {Name der Rubrik 'rausfinden, wie sie nach dem TRANSFER-File ist}
  NeuRubrikName := TransferMail(KS[ch]^.DBSFData^.Send_To);

  {Rubrik an den Filenamen anhngen}
(*  FileName := FileName + KS[ch]^.DBSFData^.Send_To;*)
  FileName := klein(FileName + NeuRubrikName);

  {$I-}
  MKDir(FileName);   {Verzeichnis erstellen}
  {$I+}
  IF IOResult=5 THEN BEGIN END;

  FileName := FileName + PATH_SEP + DatNam;

  ASSIGN(KS[ch]^.DBSFData^.f,FileName);
  REWRITE(KS[ch]^.DBSFData^.f);
  KS[ch]^.DBSFData^.FileName := DatNam;
  WRITELN(KS[ch]^.DBSFData^.f,StringD(' ',255));
  WRITELN(KS[ch]^.DBSFData^.f,StringD(' ',255));
  WRITELN(KS[ch]^.DBSFData^.f,'SND '+KS[ch]^.DBSFData^.Send_From);
{  WRITELN(KS[ch]^.DBSFData^.f,'REC '+KS[ch]^.DBSFData^.Send_To);}
  WRITELN(KS[ch]^.DBSFData^.f,'REC '+NeuRubrikName);
  WRITELN(KS[ch]^.DBSFData^.f,'SUB '+KS[ch]^.DBSFData^.Titel);
  STR(KS[ch]^.DBSFData^.LT,Hlp);
  WRITELN(KS[ch]^.DBSFData^.f,'LTM '+Hlp);
  WRITELN(KS[ch]^.DBSFData^.f,'VER '+KS[ch]^.DBSFData^.Send_Via);
  WRITELN(KS[ch]^.DBSFData^.f,'BID '+KS[ch]^.DBSFData^.BID);
  WRITELN(KS[ch]^.DBSFData^.f,'UXT ',currixtime);
  WRITELN(KS[ch]^.DBSFData^.f,'NNNN');

  IF OwnBoxData^.Header_Eintrag THEN BEGIN
    IF (KS[ch]^.DBSFData^.Send_To<>'M') AND (KS[ch]^.DBSFData^.Send_To<>'E') THEN BEGIN
      PackTime(DT,KS[ch]^.DBSFData^.RX_Date);
      WRITELN(KS[ch]^.DBSFData^.f,SFHeaderText(KS[ch]^.DBSFData^.RX_Date,FALSE,KS[ch]^.DBSFData^.BID,
                 KS[ch]^.DBSFData^.PW_Gesichert));
    END;
  END;

  KS[ch]^.DBSFData^.AuswertHeader := TRUE;
  KS[ch]^.DBSFData^.SFPartner := '';
  KS[ch]^.DBSFData^.RX_From := CutSSID(BoxCall);


END;



PROCEDURE SaveDBMail(ch: BYTE; S: STRING);
LABEL Fertig;
TYPE T_Arr255 = ARRAY[1..255] OF CHAR;
VAR Verwalt: Verwalt_Rec;
    VerwaltFile: FILE OF Verwalt_Rec;
    SR: SearchRec;
    DT: DateTime;
    OK: BOOLEAN;
    Hlp: STRING;
    IsBIN: BOOLEAN;
    lint: LONGINT;
    NeuRubrik: str8;
    Result,Anz,i,aword: WORD;
    Arr255: T_Arr255;
    Kill,Hold,SysOp: BOOLEAN;
    idxpos:WORD;
    chkpos:LONGINT;
BEGIN
  KILL:=FALSE;HOLD:=FALSE;
  IF KS[ch]^.DBSFData^.BIN THEN BEGIN
    WITH KS[ch]^.DBSFData^ DO BEGIN

      FOR i := 1 TO LENGTH(S) DO Arr255[i] := S[i];

      BLOCKWRITE(BIN_File,Arr255,LENGTH(S),Result);
      BIN_Akt := BIN_Akt + Result;
      BIN_CRC := BuildStringCRC(S,BIN_CRC);

      IF BIN_Akt=BIN_Len THEN BEGIN
        KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_LINEMODE ;
        IF BIN_CRC <> BIN_CRC_Got THEN BEGIN
          CLOSE(BIN_File);
          PutData(ch,#13+'***Checksum error'+#13);
          KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
          Exit;
        END;
        GOTO Fertig;
      END;
      Exit;
    END;

  END
  ELSE BEGIN
    IsBIN := FALSE;
    IF (COPY(S,1,5)='#BIN#') THEN BEGIN
      WITH KS[ch]^.DBSFData^ DO BEGIN
        IsBIN := TRUE;
        {#BIN# aus dem String 'rausschneiden}
        S := COPY(S,6,255);

        {Lnge nach Hlp und weiter nach BIN_Len}
        Hlp := COPY(S,1,POS('#',S)-1);
        S := COPY(S,POS('#',S)+1,255);
        VAL(Hlp,BIN_Len,aword);

        {CRC einlesen und nach BIN_CRC_Got speichern}
        Hlp := COPY(S,1,POS('#',S)-1);
        S := COPY(S,POS('#',S)+1,255);
        IF Hlp[1]='|' THEN Hlp := COPY(Hlp,2,255);
        VAL(Hlp,BIN_CRC_Got,aword);
        KS[ch]^.FLAGS := KS[ch]^.FLAGS AND NOT KS_LINEMODE;
        BIN_Akt := 0;
        BIN_CRC := 0;

        CLOSE(f);

        NeuRubrik := TransferMail(KS[ch]^.DBSFData^.Send_To);
        IF Typ = 'P' THEN ASSIGN(BIN_File,BoxPath + 'user' +PATH_SEP + klein(NeuRubrik) + PATH_SEP + FileName)
                     ELSE ASSIGN(BIN_File,BoxPath + 'info' + PATH_SEP + klein(NeuRubrik) + PATH_SEP + FileName);

        RESET(BIN_File,1);

        SEEK(BIN_File,FILESIZE(BIN_File));

        S := '#BIN';
        STR(BIN_Len,Hlp);
        S := S + '#'+Hlp;
        STR(BIN_CRC_Got,Hlp);
        FOR i := 0 TO 4 DO IF LENGTH(Hlp)=i THEN Hlp := '0' + Hlp;
        S := S + '#|'+Hlp;

        aword := 1;
        Arr255[1] := #13;
        FOR i := 1 TO LENGTH(S) DO Arr255[i+1] := S[i];
        aword := aword + LENGTH(S)+1;
        Arr255[aword] := #13;

        BLOCKWRITE(BIN_File,Arr255,aword,Result);

        BIN := TRUE;
        Exit;

      END;
    END
    ELSE IsBIN := FALSE;

    IF NOT IsBIN THEN BEGIN

      {Evtl. RETURN abschneiden}
      IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
      IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

      IF (S[1] = #26) OR (S='***END') OR (Gross(S)='/EX') THEN BEGIN
        Fertig:

        IF KS[ch]^.DBSFData^.BIN THEN CLOSE(KS[ch]^.DBSFData^.BIN_File)
                                 ELSE CLOSE(KS[ch]^.DBSFData^.f);


        {ACK-Mails fangen mit 'ACK:' im Header an...}
        IF COPY(KS[ch]^.DBSFData^.Titel,1,4)='ACK:' THEN KS[ch]^.DBSFData^.Typ := 'A'
        ELSE BEGIN
          {Lifetime kontrollieren bzw. setzen}
          IF KS[ch]^.DBSFData^.Typ = 'P' THEN BEGIN
            IF KS[ch]^.DBSFData^.LT = -1 THEN KS[ch]^.DBSFData^.LT := OwnBoxData^.User_LT;
          END
          ELSE BEGIN
            IF KS[ch]^.DBSFData^.LT >= -1 THEN CheckDBLT(KS[ch]^.DBSFData^.LT,KS[ch]^.DBSFData^.Send_To)
                                          ELSE StandardDBLT(KS[ch]^.DBSFData^.LT,KS[ch]^.DBSFData^.Send_To);
          END;
        END;

        NeuRubrik := TransferMail(KS[ch]^.DBSFData^.Send_To);



        ASSIGN(VerwaltFile,BoxPath+'index'+PATH_SEP+klein(NeuRubrik)+'.idx');
        {$I-}
        RESET(Verwaltfile);
        {$I+}
        IF IOResult = 0 THEN SEEK(VerwaltFile,FILESIZE(VerwaltFile))
                        ELSE REWRITE(VerwaltFile);

        {Verwaltungsrecord setzen}
        Verwalt.Titel := KS[ch]^.DBSFData^.Titel;
        Verwalt.Absender := KS[ch]^.DBSFData^.Send_From;
        Verwalt.Rubrik := KS[ch]^.DBSFData^.Send_To;
        Verwalt.MBX := KS[ch]^.DBSFData^.Send_Via;
        IF KS[ch]^.DBSFData^.Typ = 'P' THEN Verwalt.FileName := 'user'+PATH_SEP
	   + klein(NeuRubrik) + PATH_SEP + KS[ch]^.DBSFData^.FileName
	ELSE
	   Verwalt.FileName := 'info'+PATH_SEP + klein(NeuRubrik) + PATH_SEP + KS[ch]^.DBSFData^.FileName;
        Verwalt.RX_Datum:=Unix2Pack(CurrIxTime);
        Verwalt.BID := KS[ch]^.DBSFData^.BID;
        FindFirst(BoxPath+Verwalt.FileName,$3F,SR);
        Verwalt.Groesse := SR.Size;
        Verwalt.Lifetime := KS[ch]^.DBSFData^.LT;
        Verwalt.Flags := 0;
        {Flags: Siehe BOXVARS.PAS}

        {Evtl. Hold}
        Hold := HoldThisMail(TRUE,FALSE,Verwalt.FileName[1]='U',Verwalt,KS[ch]^.DBSFData^.Typ);



        {M_FILTER:
         Aufrufen mit Parameter Filename (incl. BoxPath).
         Rckgabe: exitcode 0: Mail OK
                            1: Hold
                            2: Kill}
        Kill := FALSE;
        IF LENGTH(OwnBoxData^.M_FILTER)>0 THEN BEGIN
	  {$IFNDEF LINUX}
          SetMemTop(HeapPtr);
          dos.exec(OwnBoxData^.M_FILTER,BoxPath+Verwalt.Filename);
          SetMemTop(HeapEnd);
	   {$ENDIF}
          IF doserror=0 THEN BEGIN
            CASE DosExitCode OF
              1: Hold := TRUE;
              2: Kill := TRUE;
            END;
          END;
        END;
        (* IF KS[ch]^.DBSFData^.SchmeissWech THEN Kill:=TRUE; *)
        IF Hold THEN
        BEGIN
          Verwalt.Flags := Verwalt.Flags OR VERWALT_HOLD;
          ProfileBox('HOLD (S&F from'+cutssid(KS[ch]^.call)+'): $'+verwalt.bid+' '+verwalt.rubrik+'@'+verwalt.mbx+
                     ' <'+verwalt.absender,PBOX_HOLD);
        END;
        {Wenn nicht als KILL oder Hold markiert, wird geguckt, ob die Mail
         fr den Server interessant ist.}
        IF NOT Kill AND NOT Hold THEN
            CheckForServer(Verwalt,Kill);


        IF NOT Kill THEN BEGIN

          {File in die S&F-Liste eintragen}
          AddSFListe(CutSSID(KS[ch]^.Call),Verwalt,KS[ch]^.DBSFData^.Typ,KS[ch]^.DBSFData^.LT_Angegeben,
                      KS[ch]^.DBSFData^.Hierach,Hold,FALSE);

          {So, die Mail ist mit der original Rubrik in die SF-Liste eingetragen.
           Fr uns lokal wird jetzt die Rubrik gendert}
          Verwalt.Rubrik := NeuRubrik;



          IF LENGTH(Verwalt.Rubrik)=1 THEN BEGIN
            SysOp := TRUE;
            IF (Verwalt.Rubrik='M') OR (Verwalt.Rubrik='E') THEN SysOp := FALSE;
          END
          ELSE SysOp := FALSE;
          idxpos:=FILEPOS(VerwaltFile)+1;
          {Mail zum Check-File dazu}
          AddCheckFile(Verwalt,idxpos,Hold,SysOp,chkpos);

          IF KS[ch]^.DBSFData^.BIN THEN BEGIN
            Verwalt.Titel := '(BIN) '+Verwalt.Titel;
            KS[ch]^.DBSFData^.BIN := FALSE;
          END;
          AddBIDFile(verwalt.BID,verwalt.rubrik,idxpos,chkpos);
          WRITE(VerwaltFile,Verwalt);
          CLOSE(VerwaltFile);

          AddOneSend(Gross(CutSSID(Verwalt.Absender)));
          IF Rufz(Verwalt.Rubrik) THEN BEGIN
            AddOneGet(Gross(CutSSID(Verwalt.Rubrik)));
            BenachrichtigeUser(Gross(CutSSID(Verwalt.Rubrik)),ch);
          END;

          OK := FALSE;
          FOR i := 1 TO AnzRub DO BEGIN
            IF DirInfo[i]^.Rubrik = Verwalt.Rubrik THEN BEGIN
              OK := TRUE;
              DirInfo[i]^.Mails := DirInfo[i]^.Mails + 1;
            END;
          END;
          IF NOT OK THEN BEGIN
            AnzRub := AnzRub + 1;
            new(DirInfo[AnzRub]);
            DirInfo[AnzRub]^.Rubrik := Verwalt.Rubrik;
            DirInfo[AnzRub]^.Mails := 1;
            DirInfo[AnzRub]^.Art := Verwalt.FileName[1];
            SortDirInfo;
          END;
        END
        ELSE BEGIN
          {Textfile wird gelscht (M_FILTER will das so)}
          ASSIGN(KS[ch]^.DBSFData^.f,BoxPath+Verwalt.Filename);
          {$I-}
          ERASE(KS[ch]^.DBSFData^.f);
          {$I+}
          IF IOResult=0 THEN BEGIN END;
          CLOSE(Verwaltfile);
        END;
        KS[ch]^.DBSFData^.status := 0;      {status: Kommandos eingeben}

        PutData(ch,'>'#13);
        KS[ch]^.DBSFData^.BIN := FALSE;
        KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_LINEMODE;
      END
      ELSE BEGIN
        WRITELN(KS[ch]^.DBSFData^.f,S);
        WITH KS[ch]^.DBSFData^ DO CheckForAutorouter(ch,S,AuswertHeader,SFPartner,RX_From,kill);
        IF kill then KS[ch]^.DBSFData^.SchmeissWech:=TRUE;
      END;
    END;
  END;

END;



FUNCTION SendFileDa(Call: str6; ForwWhat: CHAR; ForwSize: WORD): BOOLEAN;
VAR SFFile: FILE OF SF_File_Rec;
    SF: SF_File_Rec;
    Found: BOOLEAN;sr:searchrec;
BEGIN
  FOUND:=FALSE;
  IF ForwWhat = 'X' THEN
  BEGIN
     SendFileDa:= FALSE;
     exit;
  END;
  ASSIGN(SFFile,BOXPATH+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
   { Writeln('IOerr');}
    SendFileDa := FALSE;
    Exit;
  END;
  Call := Gross(Call);
  call := cutssid(call);
  WHILE NOT EOF(SFFile) AND NOT Found DO BEGIN
    READ(SFFile,SF);
    Found := TRUE;
    IF SF.SF_Partner <> Call THEN Found := FALSE;
    IF SF.Flags AND SFLISTE_DEL>0 THEN Found:=false;
    IF SF.Flags AND SFLISTE_HOLD>0 THEN Found := FALSE;
    IF (SF.Art = 'B') AND (ForwWhat = 'U') THEN Found:=False;
    IF ForwWhat = 'X' THEN Found := FALSE;
    IF (SF.Groesse > ForwSize) AND (ForwSize <> $FFFF) THEN Found := FALSE;
    FINDFIRST(boxpath+SF.Filename,anyfile,sr);
    IF (DOSERROR<>0) and (SF.An<>'M') AND (SF.An<>'E') THEN FOUND:=FALSE;
  END;
  SendFileDa := Found;
  CLOSE(SFFile);
END;


PROCEDURE SendStatusLine(ch: BYTE);
VAR SFFile: FILE OF SF_File_Rec;
    SF: SF_File_Rec;
    OK,Found: BOOLEAN;
    S: STRING;
    Hlp: STRING[3];
BEGIN
  ASSIGN(SFFile,BoxPath+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult = 0 THEN BEGIN
    Found := FALSE;
    WHILE NOT EOF(SFFile) AND NOT Found DO BEGIN
      READ(SFFile,SF);

      WITH KS[ch]^.DBSFData^ DO BEGIN
        OK := TRUE;
        IF SF.SF_Partner <> CutSSID(KS[ch]^.Call) THEN OK := FALSE;
        IF SF.Flags AND SFLISTE_DEL>0 THEN OK := FALSE;
        IF SF.Flags AND SFLISTE_HOLD>0 THEN OK := FALSE;
        IF (SF.Art = 'B') AND (ForwWhat = 'U') THEN OK := FALSE;
        IF ForwWhat = 'X' THEN OK := FALSE;
        IF (SF.Groesse > ForwSize) AND (ForwSize <> $FFFF) THEN OK := FALSE;
      END;

      IF OK THEN BEGIN
        Found := TRUE;

        WITH KS[ch]^.DBSFData^ DO BEGIN
          Send_To := SF.An;
          Send_From := SF.Von;
          Send_Via := SF.Via;
          Titel := SF.Titel;
          Hierach := SF.Hierachie;
          Typ := SF.Art;
          IF (UpCase(Typ)='M') OR (UpCase(Typ)='E') THEN Typ := 'B';
          IF (UpCase(Typ)='A') AND NOT KS[ch]^.DBSFData^.Features.A THEN Typ := 'P';
          BID := SF.BID;
          LT := SF.LT;
          FileName := SF.FileName;
        END;

        {Wenn der S&F-Partner eine DieBox oder BayBox ist, und wenn wir
         die DieBox-SID benutzen, wird das verkrzte Format von DieBox
         verwendet.}
        IF ((SF.Art='M') OR (SF.Art='E')) AND KS[ch]^.DBSFData^.TheBox_E_M_Format THEN BEGIN
          S := 'S M @ '+SF.Via+' < '+SF.Von+' $'+SF.BID+' '+SF.Titel+' '+#26;
          PutData(ch,S+#13);

          KS[ch]^.DBSFData^.status := 4;
        END
        ELSE BEGIN
          S := 'S'+KS[ch]^.DBSFData^.Typ + ' ' + SF.An + ' @ ' + SF.Via;
          IF KS[ch]^.DBSFData^.Features.H THEN S := S + KS[ch]^.DBSFData^.Hierach;
          S := S + ' < ' + SF.Von;
          IF ((SF.Art = 'P') AND KS[ch]^.DBSFData^.Features.M) OR (SF.Art = 'B') OR ((SF.Art = 'G')
             AND KS[ch]^.DBSFData^.Features.G) THEN BEGIN
            S := S + ' $' + SF.BID;
          END;
          STR(SF.LT,Hlp);
          IF KS[ch]^.DBSFData^.Features.D AND (SF.Flags AND SFLISTE_LTMIT>0) THEN S := S + ' #' + Hlp;
          PutData(ch,S+#13);

          {Status setzen}
          KS[ch]^.DBSFData^.status := 3;
        END;
      END;
    END;
    CLOSE(SFFile);
  END;
END;


PROCEDURE SendDBFile(ch: BYTE; S: STRING);
VAR Nr: WORD;
BEGIN
  IF SendFileDa(CutSSID(KS[ch]^.Call),KS[ch]^.DBSFData^.ForwWhat,KS[ch]^.DBSFData^.ForwSize) THEN BEGIN
    SendStatusLine(ch);
  END
  ELSE BEGIN
    IF NOT KS[ch]^.DBSFData^.F_Get THEN BEGIN
      PutData(ch,'F>'+#13);
      KS[ch]^.DBSFData^.F_Get := TRUE;
      KS[ch]^.DBSFData^.status := 5;
    END
    ELSE BEGIN
      KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
    END;
  END;
END;

PROCEDURE DelSFFileEntry(BID: str12; Call: str6);
VAR SFFile: FILE OF SF_File_Rec;
    SF: SF_File_Rec;
    Found: BOOLEAN;
BEGIN
  ASSIGN(SFFile,BoxPath+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  PROFILEBOX('delsffilentry:'+bid,PBOX_DEBUG);
  IF IOResult = 0 THEN BEGIN
    Found := FALSE;
    {If there are to entries of the same BID in the "sfliste", then mcut got}
    WHILE NOT EOF(SFFile) {AND NOT Found} DO BEGIN
      READ(SFFile,SF);
      IF (BID = SF.BID) AND (SF.SF_Partner = Call) THEN BEGIN
        Found := TRUE;
        SEEK(SFFile,FILEPOS(SFFile)-1);
        SF.Flags := SF.Flags OR SFLISTE_DEL;
	PROFILEBOX('delsffilentry:found',PBOX_DEBUG);
        WRITE(SFFile,SF);
      END;
    END;
    CLOSE(SFFile);
  END;
END;



PROCEDURE LookOK_NO(ch: BYTE;S: STRING);
TYPE T_Arr250 = ARRAY[1..250] OF CHAR;
VAR f: Text;
    BIN_File: FILE;
    LenHeader: LONGINT;
    BIN: BOOLEAN;
    Result,i: WORD;
    Arr250: T_Arr250;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);
  IF S='' THEN Exit;

  {Initialisierung}
  KS[ch]^.DBSFData^.UsermailAbgelehnt := FALSE;

  IF S[1] = 'N' THEN BEGIN
    IF KS[ch]^.DBSFData^.Typ='P' THEN KS[ch]^.DBSFData^.UsermailAbgelehnt := TRUE;
    DelSFFileEntry(KS[ch]^.DBSFData^.BID,CutSSID(KS[ch]^.Call));
    KS[ch]^.DBSFData^.status := 4;
    Exit;
  END;
  PutData(ch,KS[ch]^.DBSFData^.Titel+#13);

  IF NOT (UpCase(KS[ch]^.DBSFData^.Typ)='M') AND NOT (UpCase(KS[ch]^.DBSFData^.Typ)='E') THEN BEGIN
    {Keine M- oder E-Mail - Body+SF-Header senden}


    ASSIGN(f,BoxPath+KS[ch]^.DBSFData^.FileName);
    {$I-}
    RESET(f);
    {$I+}
    IF IOResult <> 0 THEN BEGIN
      PutData(ch,#13+'*** Fehler beim ffnen der Datendatei...'#13);
      KS[CH]^.Flags:=KS[CH]^.Flags AND KS_DISCREQ;
      KS[ch]^.DBSFData^.status := 4;
      Exit;
    END;

    LenHeader := 0;
    WHILE NOT EOF(f) AND (S <> 'NNNN') DO BEGIN
      READLN(f,S);
      LenHeader := LenHeader + LENGTH(S) + 2;
    END;

    BIN := FALSE;
    WHILE NOT EOF(f) AND NOT BIN DO BEGIN
      READLN(f,S);
      IF COPY(S,1,5)='#BIN#' THEN BIN := TRUE
      ELSE BEGIN
        LenHeader := LenHeader + LENGTH(S) + 2;
        PutData(ch,S+#13);
      END;
    END;
    CLOSE(f);

    IF BIN THEN BEGIN
      ASSIGN(BIN_File,BoxPath+KS[ch]^.DBSFData^.FileName);
      RESET(BIN_File,1);
      SEEK(BIN_File,LenHeader-1);
      REPEAT
        BLOCKREAD(BIN_File,Arr250,250,Result);
        S[0] := Chr(Result);
        FOR i := 1 TO Result DO S[i] := Arr250[i];
        PutData(ch,S);
      UNTIL Result < 250;
      CLOSE(BIN_File);
    END;
  END;

  PutData(ch,#26#13);

  KS[ch]^.DBSFData^.status := 4;
END;



PROCEDURE WaitForSFPrompt(ch: BYTE; S: STRING);
BEGIN
  IF S[LENGTH(S)-1] <> '>' THEN Exit;
  KS[ch]^.DBSFData^.status := 11;

  {SID senden}
  CASE What_SID(CutSSID(KS[ch]^.Call)) OF
    1: PutData(ch,SID);
    2: PutData(ch,THEBOX_SID);
    ELSE PutData(ch,SID);
  END;
  IF LENGTH(KS[ch]^.DBSFData^.PwdAnswer)>0 THEN PutData(ch,' '+KS[ch]^.DBSFData^.PwdAnswer+#13)
                                           ELSE PutData(ch,#13);
END;



PROCEDURE WaitForSFOKPrompt(ch: BYTE; S: STRING);
BEGIN
  IF S[1] <> '>' THEN Exit;
  SendDBFile(ch,S);
END;



PROCEDURE DelSFUserFile(BID:str12; Call: str6);
VAR VerFile: FILE OF Verwalt_Rec;
    Ver: Verwalt_Rec;
    k,Rub: WORD;
    Found: BOOLEAN;
BEGIN

  ASSIGN(VerFile,BOXPATH+'index'+PATH_SEP+klein(Call)+'.idx');
  {$I-}
  RESET(VerFile);
  {$I+}
  IF IOResult = 0 THEN BEGIN
    IF NOT EOF(VerFile) THEN BEGIN
      REPEAT
        READ(VerFile,Ver);
      UNTIL EOF(VerFile) OR (Ver.BID = BID);
      IF Ver.BID = BID THEN BEGIN

        SEEK(VerFile,FILEPOS(VerFile)-1);
        {Gelscht-Flag setzen. Flags: Siehe BOXVARS.PAS}
        Ver.Flags := Ver.Flags OR VERWALT_DEL;
        WRITE(VerFile,Ver);

        IF Rufz(Ver.Rubrik) THEN BEGIN

          Found := FALSE;
          FOR k := 1 TO AnzRub DO BEGIN
            IF Call = DirInfo[k]^.Rubrik THEN BEGIN
              Found := TRUE;
              Rub := k;
            END;
          END;

          DirInfo[Rub]^.Mails := DirInfo[Rub]^.Mails - 1;
          IF DirInfo[Rub]^.Mails = 0 THEN BEGIN
            FOR k := Rub TO AnzRub-1 DO BEGIN
              DirInfo[k]^ := DirInfo[k+1]^;
            END;
            DISPOSE(DirInfo[AnzRub]);
            DirInfo[AnzRub] := NIL;
            AnzRub := AnzRub - 1;
          END;
        END;
      END;
    END;
    CLOSE(VerFile);
  END;
END;



{Von der Station, die auf Kanal ch eingeloggt ist, wurde eine Usermail
 abgelehnt. Es scheint eine Schleife zwischen Systemen aufgetreten zu
 sein, die MIDs vergeben. Error-Message an den SysOp}
PROCEDURE CreateSysopMail_RejectUsermail(ch: BYTE);
VAR f,f2: Text;
    Line: WORD;
    S,Hlp: STRING;
    i: BYTE;
BEGIN
   ASSIGN(f2,BoxPath+'msg'+PATH_SEP+'reject.usr');
  {$I-}
  RESET(f2);
  {$I+}
  IF IOResult<>0 THEN Exit;

  ASSIGN(f,BoxPath+'import'+PATH_SEP+FindUniqueImportFilename);
  {$I-}
  REWRITE(f);
  {$I+}
  IF IOResult<>0 THEN Exit;

  {Empfnger der Mail}
  WRITELN(f,'SP '+CutSSID(BoxCall)+' < SYSTEM');

  Line := 0;
  WHILE NOT EOF(f2) DO BEGIN
    inc(Line);
    READLN(f2,S);

    i := 1;
    Hlp := '';
    WHILE i<=LENGTH(S) DO BEGIN
      IF S[i]='%' THEN BEGIN
        inc(i);
        IF i<=LENGTH(S) THEN BEGIN
          CASE S[i] OF
            'U': Hlp := Hlp + KS[ch]^.DBSFData^.Send_To;
            'B': Hlp := Hlp + KS[ch]^.Call;
            'I': Hlp := Hlp + KS[ch]^.DBSFData^.BID;
            'S': Hlp := Hlp + KS[ch]^.DBSFData^.Send_From;
          END;
        END;
      END
      ELSE Hlp := Hlp + S[i];

      inc(i);
    END;
    WRITELN(f,Hlp);
  END;
  CLOSE(f);
  CLOSE(f2);

END;




{Status-Auswertung der DieBox-S&F-Mails}
PROCEDURE DieBox_SF(ch: BYTE; S: STRING);
BEGIN
  CASE KS[ch]^.DBSFData^.status OF
     0: IF COPY(S,1,2) = 'F>' THEN BEGIN
          SendDBFile(ch,S);
        END
        ELSE BEGIN
          IF s[1]='*' THEN BEGIN
            KS[ch]^.FLAGS := KS[ch]^.FLAGS OR KS_DISCREQ;
            Exit;
          END
          ELSE CheckDBSendLine(ch,S);
        END;
     1: GetDBTitel(ch,S);
     2: SaveDBMail(ch,S);
     3: LookOK_NO(ch,S);
     4: BEGIN
          IF S[1] = #13 THEN Exit;
          IF POS('>',S)>0 THEN BEGIN
            DelSFFileEntry(KS[ch]^.DBSFData^.BID,CutSSID(KS[ch]^.Call));
            IF KS[ch]^.DBSFData^.UsermailAbgelehnt THEN BEGIN
              CreateSysopMail_RejectUsermail(ch);
            END
            ELSE BEGIN
              IF Rufz(KS[ch]^.DBSFData^.Send_To) THEN DelSFUserFile(KS[ch]^.DBSFData^.BID,KS[ch]^.DBSFData^.Send_To);
              AddForwardMarker(CutSSID(KS[ch]^.Call),BoxPath+KS[ch]^.DBSFData^.FileName);
            END;
          END;
          SendDBFile(ch,S);       {Vorschlag machen, wenn vorhanden}
        END;
     5: CheckDBSendLine(ch,S);
    10: WaitForSFPrompt(ch,S);
    11: WaitForSFOKPrompt(ch,S);
  END;
END;



PROCEDURE GetWhatToForwardList(ch: BYTE; VAR What: CHAR; VAR Size: WORD);
VAR f: Text;
    S: STRING;
    OK: BOOLEAN;
    Spalte,aword: WORD;
    ISpalte:Integer;
    tmp: pBoxSF;
BEGIN
  GetTime(Spalte,aword,aword,aword);
  ISpalte := Spalte-UtcOffset;
  IF ISpalte<0 THEN
    ISpalte:=ISpalte+24;

  Size := $FFFF;        {Maximale Gre}
  What := ' ';          {Alles forwarden}

  tmp := BoxSFRoot;
  OK := FALSE;
  WHILE (tmp<>NIL) AND NOT OK DO BEGIN
    IF CutSSID(KS[ch]^.Call)=tmp^.Call THEN BEGIN
      CASE tmp^.WhatToForward[Spalte] OF
        'A': What := 'A';
        'U': What := 'U';
        'X': What := 'X';
        'N': What := 'A';
      END;
      OK := TRUE;
    END;
    tmp := tmp^.next;
  END;
END;


FUNCTION CalcBayPassWord_SF(channel:BYTE;s2:string):STRING;
VAR s,s3,pwd:string;
     baypass:array[1..5] OF byte;
     f:text;
     b,b2:byte;
BEGIN
  b:=1;
  b2:=0;
  s3:='';
  {if not fileda( boxpath + klein(cutssid(KS[channel]^.call))+'.pwb') THEN exit;}
  {$I-}
  assign(f, boxpath + klein(cutssid(KS[channel]^.call))+'.pwb');
  reset(f);
  IF IORESULT <> 0 THEN Exit;
  READLN(f,pwd);
  CLOSE(f);
  pwd:=rtrim(pwd);
  pwd:=ltrim(pwd);

  (* MD2-Passwort-Berechnung nach DPBOX-Verfahren.
     Benoetigt MD2.EXE im MCUT-Verzeichnis. *)

  IF (S2[1]='[') AND (S2[12]=']') THEN
  BEGIN
     {$IFNDEF LINUX}
    SetMemTop(HeapPtr);
    EXEC(getenv('COMSPEC'),'/C '+qrvpath+'MD2 '+copy(s2,2,10)+' '+pwd+' > '+qrvpath+'MD2.$$$');
    SetMemTop(HeapEnd);
     {$ENDIF}
    {$I-}
    ASSIGN(f,qrvpath+'MD2.$$$');
    RESET(f);
    IF IORESULT<>0 THEN
    BEGIN
      PROFILEBOX('Error generating MD2 password: MD2.$$$ not found',PBOX_IOERROR);
      exit;
    END;
    ReadLn(f,S);
    CLOSE(f);
    CalcBayPassWord_SF:=s;
    exit;
  END;
  s2:=s2+' ';
  WHILE b <= length(s2) DO
  BEGIN
    IF s2[b] IN ['0'..'9'] THEN
    BEGIN
      s3:=s3 + s2[b]
    END
    ELSE
    BEGIN
      inc(b2);
      BEGIN
        val(s3, baypass[b2], err);
        s3:='';
      END;
    END;
    inc(b);
  END;
  s[0]:=#5;
  for b:=1 to 35 do
  BEGIN
    S3[b]:=char(random(122-48)+48);
    IF s3[b]=';' THEN s3[b]:='%';
  END;
  S3[0]:=#35;
  FOR b:=1 TO 5 DO
    s[b]:=pwd[baypass[b]];
  insert(s,s3,random(30)+1);
  CalcBayPassWord_SF:=s3;
END;

{Wir haben connected}
PROCEDURE SFConnectDID(ch: BYTE; S: STRING);
VAR i: WORD;
    Is_SID: BOOLEAN;
    Hlp: STRING[80];
    Use_SID: BYTE;
    Pwd: STRING[40];

BEGIN

  IF (POS('[',S) = 0) OR (POS(']',S) = 0) THEN Exit;

  {Kontrolle, welche SID benutzt werden soll}
  Use_SID := What_SID(CutSSID(KS[ch]^.Call));

  {Gucken, ob das verkrzte DieBox-Format fr E und M-Mails verwendet
   wird}
  Hlp := COPY(S,POS('[',S)+1,255);
  Hlp := Gross(COPY(Hlp,1,POS('-',Hlp)-1));
{  IF (Hlp='THEBOX') OR (Hlp='BAYCOM') THEN KS[ch]^.DBSFData^.TheBox_E_M_Format := TRUE
                                      ELSE KS[ch]^.DBSFData^.TheBox_E_M_Format := FALSE;
  IF Use_SID<>2 THEN KS[ch]^.DBSFData^.TheBox_E_M_Format := FALSE;
}

  {Kontrolle, ob ein Passwort angegeben wurde}
  Pwd := '';
  IF POS(' ',S) > POS(']',S) THEN BEGIN
    Hlp := COPY(S,POS(']',s)+2,255);
    {POS(' ',Hlp)>0 DO Hlp := COPY(Hlp,POS(' ',Hlp)+1,255);}
    IF (POS(' ',hlp)>0) OR ((hlp[1]='[') AND (hlp[12]=']')) THEN
    BEGIN
      pwd := CalcBayPassWord_SF(ch,hlp);
    END ELSE
    BEGIN
      Pwd := CalcPassword_SF(ch,Hlp);
    END;
  END;


  IF POS('[',S) > 0 THEN DELETE(S,POS('[',S),1);
  IF POS(']',S) > 0 THEN DELETE(S,POS(']',S),1);

  {Alle Felder in der Mitte abschneiden}
  WHILE POS('-',S) > 0 DO S := COPY(S,POS('-',S)+1,255);

  {Untersttzt die Gegenseite S&F nach F6FBB?}
  IF (POS('F',S) > 0) AND (Use_SID=1) THEN BEGIN
    NEW(KS[ch]^.FBBSFData);
    IF KS[ch]^.Status=61 THEN KS[ch]^.FBBSFData^.TPKMode:=TRUE;
    KS[ch]^.status := 52;       {FBB-S&F}
    KS[ch]^.FBBSFData^.status := 20;     {Proposal senden}
    KS[ch]^.FBBSFData^.AnzProposal := 0; {Noch ein Proposal empfangen}
    KS[ch]^.FBBSFData^.Temp := '';
    KS[ch]^.FBBSFData^.ChckSum := 0;     {Checksumme mit 0 vorladen}
    KS[ch]^.FBBSFData^.Chck16 := 0;
    KS[ch]^.FBBSFData^.PwdAnswer := Pwd;
    KS[ch]^.FBBSFData^.TPKMode:=FALSE;
    IF NOT KS[ch]^.FBBSFData^.TPKMode THEN
    GetWhatToForwardList(ch,KS[ch]^.FBBSFData^.ForwWhat,KS[ch]^.FBBSFData^.ForwSize);

    WITH KS[ch]^.FBBSFData^.Features DO BEGIN
      A := FALSE;
      M := FALSE;
      G := FALSE;
      H := FALSE;
      D := FALSE;
      B := FALSE;
      B_Lev := 0;
      R := FALSE;
      FOR i := 1 TO LENGTH(S) DO BEGIN
        CASE S[i] OF
          'A': A := TRUE;
          'M': M := TRUE;
          'G': G := TRUE;
          'H': H := TRUE;
          'D': D := TRUE;
	  { $IFNDEF LINUX}
          'B': B := TRUE;
	  { $ENDIF}
{$IFDEF B1}
          'R': R := TRUE;
          '1': IF S[i-1]='B' THEN B_Lev := 1;
{$ENDIF}
        END; { case }	
      END;
      IF  KS[ch]^.FBBSFData^.TPKMode THEN
      BEGIN
	D:=FALSE;B:=TRUE;R:=FALSE;
      END;	
    END;
    {Bei FBB wird nach der SID KEIN(!) Prompt ausgesendet!
     einfach auf den Proposal (Liste der zu empfangenen (vielleicht, hi)
     mails) warten}
  END
  ELSE BEGIN
    NEW(KS[ch]^.DBSFData);
    KS[ch]^.status := 51;
    KS[ch]^.DBSFData^.status := 10;     {Warten auf '>'}
    KS[ch]^.DBSFData^.F_Get := FALSE;
    KS[ch]^.DBSFData^.PwdAnswer := Pwd;
    KS[ch]^.DBSFData^.SchmeissWech:=FALSE;
    GetWhatToForwardList(ch,KS[ch]^.DBSFData^.ForwWhat,KS[ch]^.DBSFData^.ForwSize);

    WITH KS[ch]^.DBSFData^.Features DO BEGIN
      A := FALSE;
      M := FALSE;
      G := FALSE;
      H := FALSE;
      D := FALSE;
      B := FALSE;
      B_Lev := 0;
      R := FALSE;
      FOR i := 1 TO LENGTH(S) DO BEGIN
        CASE S[i] OF
          'A': A := TRUE;
          'M': M := TRUE;
          'G': G := TRUE;
          'H': H := TRUE;
          'D': D := TRUE;
          'B': B := TRUE;
{$IFDEF B1}
          'R': R := TRUE;
          '1': IF S[i-1]='B' THEN B_Lev := 1;
{$ENDIF}
        END;
      END;
    END;
  END;

END;



END.
