(****************************************************************************)
(* Globale Variablen, Konstanten und Typen von MCUT.                        *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(****************************************************************************)
UNIT IADVar;

INTERFACE

USES
     MCUTBUF,
     {$IFDEF BOX}
     BOXVARS,
     {$ENDIF}
     {$IFDEF CONVERS}
     CONVVAR,
     {$ENDIF}
     CRT,
     DOS;

CONST
   PATH_SEP = {$IFDEF LINUX} '/' {$ELSE} '\' {$ENDIF};
   MAX_PATH = {$IFDEF LINUX} 255 {$ELSE} 20 {$ENDIF};
TYPE

  STRING8  = STRING[8];
  STRING6  = STRING[6];
  STRING10 = STRING[10];
  STRING12 = STRING[12];
  STRING20 = STRING[20];
  STRING40 = STRING[40];
  STRING80 = STRING[80];
  str6     = STRING[6];
  str2     = STRING[2];
  SortArray=ARRAY[1..10] Of str6;
  MsgSTring=STRING;
  TUmlautTable=ARRAY[BYTE] OF CHAR;


CONST

   PGP_SAVE_PK     = 1;
   PGP_CHECK_SIG   = 2;
   PGP_SIGN_MSG    = 4;
   PGP_SAVING_PK   = 8;
   PGP_SAVING_MSG  = 16;


(*************************************************************************)
(*       Konstanten fr das Bitfeld TKanalStatus.Flags  (iad, dez 95)    *)
(*************************************************************************)
   (* BIN- und 7PLUS automatisch abspeichern... *)
   KS_AUTOSAVE     =  1;
   (* Es ist gerade eine 7PLUS-Speicherung aktiv (bei stop_7+ file schliessen)*)
   KS_7PSAVE       =  2;
   (* Die Gegenstation ist Sysop *)
   KS_SYSOP        =  4;
   (* Der Kanal ist Inaktiv, keine //-Befehle, kein Autosave, keine
    * Auswertung von connect-meldungen *)
   KS_INACTIVE     =  8;
   (* Der Kanal soll nach Ausgabe aller Daten disconnected werden *)
   KS_DISCREQ      = 16;
   (* Auf dem Kanal wurde selbst ein Connect angestossen *)
   KS_OWNCON       = 32;
   (* Auf dem Kanal luft eine CRONTAB-Aufgabe *)
   KS_CRONTASK     = 64;
   (* Die ReceiveQueue darf an die Handle() weitergegeben werden,
    * das aktive Modul ist empfangsbereit*)
   KS_RECEIVEREADY = 128;
   (* Die Daten zeilenweise an Handle() bergeben *)
   KS_LINEMODE     = 256;
   (* Es sind Daten auf dem Kanal eingetroffen *)
   KS_CHANGED      = 512;
   (* Empfangsdaten im Scrollbuffer anzeigen *)
   KS_SHOWDATA     = 1024;
   (* Die Userdaten sind SSID-Spezifisch *)
   KS_SAVESSID     = 2048;
   (* darf remotes ausfhren *)
   KS_REMOTE       = 4096;
   (* connect-meldung auswerten *)
   KS_CONNECT      = 8192;
   (* reconnect-meldung auswerten *)
   KS_RECONNECT    = 2*KS_CONNECT;
   (* darf sysop werden *)
   KS_GETSYSOP     = 2*KS_RECONNECT;
   (* passwort automatisch senden *)
   KS_SENDPW       = 2*KS_GETSYSOP;
   (* BBS-List etc auswerten *)
   KS_BBS          = 2*KS_SENDPW;
   (* Daten sind defaults, kein eintrag in termuser *)
   KS_UNKNOWN      = 2*KS_BBS;
   
(*************************************************************************)
(*      Konstanten fr TTermUserRec.Flags                  (iad, feb 95) *)
(*************************************************************************)

   TU_SAVESSID     = 1;
   TU_AUTOSAVE     = 2;
   TU_SYSOP        = 4;
   TU_REMOTE       = 8;
   TU_CONNECT      = 16;
   TU_RECONNECT    = 32;
   TU_BBS          = 64;
   TU_SENDPW       = 128;
   TU_EXCLUDED     = 256;
   TU_INACTIVE     = 512;
   TU_UNKNOWN      = 1024;

(*************************************************************************)
(*     Konstanten fr TTermUserRec.REMOTES                               *)
(*************************************************************************)

   RM1_QUIT        = 1;
   RM1_RING        = 2;
   RM1_ECHO        = 4;
   RM1_RTT         = 8;
   RM1_INFO        = 16;
   RM1_CS          = 32;
   RM1_USER        = 64;
   RM1_HELP        = 128;
   RM1_SYSOP       = 256;
   RM1_DIR         = 1024;
   RM1_READ        = 2048;
   RM1_WRITE       = 4096;
   RM1_RPRG        = 8192;
   RM1_WPRG        = 16384;
   RM1_NAME        = 32768;
   RM1_MH          = 65536;
   RM1_RUN         = 131072;
   RM1_BOX         = 262144;
   RM1_DOS         = 524288;
   RM1_NODE        = 1048576;
   RM1_CONNECT     = 2097152;
   RM1_COMPRESS    = 4194304;
   RM1_VERSION     = 8388608;
   RM1_TIME        = 16777216;
   RM1_XRUN        = 33554432;
   RM1_REBOOT      = 67108864;
   RM1_TNC         = 134217728;
   RM1_FORCE       = 268435456;
   RM1_CONVERS     = 536870912;
   RM1_KILL        = 1073741824;

(*************************************************************************)
(*      Konstanten fr den Monitor.                                      *)
(*************************************************************************)

   MON_UI   = 1;
   MON_I    = 2;
   MON_CTL  = 4;
   MON_TXT  = 8;
   MON_TXD  = 16;

(*************************************************************************)
(*      Konstanten fr AX25-Frametypen, entsprechen FLXAPP (iad, dez 95) *)
(*************************************************************************)
CONST
      Fr_I    = 1;
      Fr_RR   = 2;
      Fr_RNR  = 3;
      Fr_REJ  = 4;
      Fr_SABM = 5;
      Fr_DISC = 6;
      Fr_DM   = 7;
      Fr_UA   = 8;
      Fr_FRMR = 9;
      Fr_UI   = 10;

(*************************************************************************)
(*       Konstanten fr den derzeitigen Status der Console               *)
(*************************************************************************)

     CONS_TERM=0;
     CONS_EDIT=1;
     CONS_DIALOG=4;
     CONS_HELP=5;
     CONS_MONI=8;
     CONS_DIR=9;
     CONS_SPY=10;
     CONS_MH=11;
     CONS_UNPROTO=12;
     CONS_BBSLIST=13;

(*************************************************************************)
(*    Variablen fuer die Bildschirmausgabe      (iad, dez 95)            *)
(*************************************************************************)

   LastConsoleState:BYTE=0;
   ConsoleState:Byte=0;        {0=Terminal,1=InputS,2=InputData,Editor,Spy etc}
   ScreenWriteOk:BOOLEAN=TRUE; {Darf auf den Screen geschrieben werden?
                                whrend PopUp = FALSE}
   Ins_Mode:BOOLEAN=TRUE;      {Einfgemodus aktiv}
   PopUp_Aktiv:BOOLEAN=FALSE;  {Es ist gerade ein Pop-Up Fenster offen}
   PopUp_Start:LONGINT=0;      {Zeitpunkt an dem das PopUp geffnet wurde}
   Which_Dialog:WORD=0;        {Welcher Dialog wurde gerade beendet?}
   Which_FileSelect:BYTE=0;
   Current_Spy:BYTE=1;
  

(**************************************************************************)
(*   Interface zu MoniRPL von DG9EP, siehe PACKET.PAS                     *)
(*   iad, aug 96                                                          *)
(**************************************************************************)

CONST  MONI_RPL_FILE_SIZE : LONGINT = 100*1024;
       MONI_RPL_AN : BOOLEAN = FALSE;



TYPE

(*************************************************************************)
(*   Configurations-Records die als Konstanten am Ende des EXE Files     *)
(*   und nach der Compilierung eingepatcht werden.                       *)
(*************************************************************************)

  tConfigData=RECORD
    pos_of_config_data:longint;
    crc_von_exe:WORD;
    crc_von_ovr:WORD;
    ovr_buf_size:LONGINT;
    ID:STRING10;
  END;

  TVersionData=RECORD
    call:string[12];
    sysopcall:string[12];
    name,vorname:STRING[40];
    plz:longint;
    ort:string[30];
    serialnumber:word;
  END;

(*************************************************************************)
(*  Der alte RECORD aus 0.28, beschreibt einen AX25 Header               *)
(*  sollte demnchst durch MCUTFRameRec ersetzt werden.                  *)
(*************************************************************************)

  HeadRec=RECORD
	    fmC,toC: STRING;
	    Count,Typ,ns,nr,port,pid,txd: BYTE;
	    len: WORD;
					 
   END;

(*************************************************************************)
(* Der neue RECORD zur Beschreibung eines AX25 Frames, kompatibel zum    *)
(* FLXAPP Format                                                         *)
(*************************************************************************)

   Mstrmax=ARRAY[1..300] of CHAR;
   pMCUTFrameRec=^MCUTFrameRec;
   MCUTFrameREC=RECORD
     Dest       : STRING10; { Zielcall                            }
     Source     : STRING10; { Absendercall                        }
     digis      : BYTE;     { Anzahl Digipeater 0-8               }
     NextDigi   : BYTE;     { Nummer des nchsten Digis           }
     MCUTPort   : BYTE;     { Kanalnummer                         }
     AXV2       : BOOLEAN;  { TRUE wenn AX25 Version 2            }
     PID        : BYTE;     { Protocol Identifier                 }
     Typ        : BYTE;     { Frametyp siehe unten                }
     Cmd        : BOOLEAN;  { TRUE wenn V2 und Command            }
     PF         : BOOLEAN;  { TRUE wenn V2 und Poll/Final         }
     nr         : BYTE;     { RX Sequence Number                  }
     ns         : BYTE;     { TX Sequence Number                  }
     Dama       : BOOLEAN;  { Flag: f. Monitor oder TX            }
     tx         : BYTE;     { f. Trace: 0 wenn RX                 }
     TextLen    : Word;     { Laenge Text wenn I, UI oder FRMR    }
     Text       : ^MStrMax; { Ptr auf Text. Als Array ansprechen! }
     QsoNum     : Word;     { von L2: Frame gehoert zu QSO        }
     Partner_Num: Word;     { von L2: Qsonummer bei Partner       }
     Digi       : ARRAY [1..8] OF STRING10;
                            { Digicalls, nur gueltig entsprechend }
                            { Anz. 'AnzDigis'                     }
   END;


   tTNCparms=RECORD
     persist,wait,txd,maxretry,paclen:BYTE;
     frack,t2,t3:LONGINT;
   END;

   PCmd=^TCmd;
   Tcmd=RECORD
     cmd        : STRING[15];
     nr         : WORD;
     lev,slev   : BYTE;
     next       : PCMD;
   END;

   pHeard=^tHeard;
   theard=RECORD
     time       : LONGINT;
     call       : STRING[10];
     via        : ^STRING;
     port       : BYTE;
     next       : pHeard;
   END;

   PQueueRec=^TQueueRec;
   TQueueRec=RECORD
     typ        : BYTE;
     next       : PQueueRec;
     data       : STRING;
   END;

   TVorschreib=RECORD
     Buf        : ARRAY[1..10] of STRING[80];
     x,y,offs   : BYTE;
   END;


   TAutoBinData=RECORD
      FileName  : STRING[70];
      BinFile   : FILE;
      CRC       : WORD;
      Received,
      Expected,
      StartTime : LONGINT;
   END;

   PCronData=^TCronData;
   TCronData=RECORD
      tag,mon,jahr,std,min,sec,wochentag:str2;
      aktion:^string;
      next:pcrondata;
   END;


   {$IFDEF CONVERS}
   TConvData=RECORD
      Chan: WORD;
      Call: STRING[6];
      Person: STRING[40];
      ChanOp,
      Beep,
      Wandel,
      Away      : BOOLEAN;
   END;

   {$ENDIF}


   TConnScriptData=RECORD
     Script            : pQueueRec;
     ConnMessages,
     DiscMessages      : Array[1..5] OF STRING[80];
     Conn_Befehl       : STRING[80];
     DIGI,USER         : STRING[10];
     starttime         : LONGINT;
     laststatus        : BYTE;
   END;

   PVar=^TVAR;
   TVAR=RECORD
      Ident,Wert:^STRING;
      next:PVAR;
   END;

   PCallstack=^TCallStack;
   TCallStack=RECORD
     ip:WORD;
     next:pCallStack;
   END;

   PScript=^TScript;
   TScript=RECORD
      programm:ARRAY[1..500] OF ^STRING;
      ip,size:WORD;
      sleepuntil:LONGINT;
      status:BYTE;
      suchstr:ARRAY[1..10] OF STRING;
      found,anzsuch:BYTE;
      Vars:PVAR;
      CallStack:pCallStack;
   END;


   PKanalRec=^TKanalRec;
   TKanalRec= RECORD
     Call              : STRING[11];
     Status            : BYTE;     {das alte status[]^.status}
     LastStatus        : BYTE;     {das alte status[]^.substate}
     LOOP              : BYTE;     {gegenkanal fr LOOP}
     Name              : STRING[20];
     SendQueue,                    {Warteschlange -> TNC }
     ReceiveQueue      : PQueueRec;{Warteschlange -> Handle }
     ReceiveRest,                  {Unvollstndige Zeile (ohne CR)}
     SendRest          : STRING;   {fr Paclen, evtl gar nicht gebraucht}
     Prio              : BYTE;     {wenn >0 wird handle auch aufgerufen, wenn
                                    keine Daten vorliegen}
     Compress,
     SendMode          : BYTE;     {0=Daten,1=Textfile,2=Binrfile}
     SendFile          : FILE;     {Sende-Datei fr PutFile/PutBinFile}
     unack,tries,lstate,
     BufSize,
     Lev,                          {Benutzer-Level}
     Port,                         {PORT bei DRSI}
     CrossChan,                    {Gegenkanal bei CrossConnect}
     MaxFrame,
     PacLen            : BYTE;     {fr Ausgabe ans TNC}
     pass              : WORD;     {Ausgegebene Zahlenfolge bei SY}
     SleepUntil,                   {UnixTime bis zu der der Task pennen soll}
     Create,IdleSince  : LONGINT;   {Zeitpunkt, wann dieser KS erzeugt wurde,
                                    unixtime}
     RxBy,TxBy,
     RxW,TxW,
     CompTx,CompRx : LONGINT;   {Diverse Dinge fr Statistik}
     AutoBinData       : ^TAutoBinData;
     TxUmlautTable,RXUmlautTable,UmlautMode:BYTE;
     Ring_ANZ:BYTE;
     transferred,expected,
     transferstart,
     FLAGS             : LONGINT;  {hier stehen die einzelnen Booleans
                                    von frher, z.b. DISCREQ,LINEMODE etc.
                                     siehe CONST KS_ oben} 
     REMOTES           : LONGINT;			   
     DATEI             : ^TEXT;				   
     ConnScriptData    : ^TConnScriptData;		   
     Stream            : WORD;     {kanalnummer bzw QSO-Nummer bei Flexnet}
     pw,prefix         : STRING20;			   
     filename          : {$IFDEF linux} STRING {$ELSE} STRING20 {$ENDIF};
		
     pwtyp             : BYTE;				   
     rempath,
     path              : STRING;
     LinkState,TYP     : BYTE;
     PGPFlags:WORD;
     PGPSave:^Text;

     {$IFDEF CONVERS}
     ConvData          : ^TConvUser;
     {$ENDIF}
     {$IFDEF CONVNEU}
     ConvHost          : pHostListe;
     {$ENDIF}
     {$IFDEF CONVNETZ}
     ConvHost          : pHostListe;
     {$ENDIF}
     {$IFDEF BOX}
     BoxData           : ^TBoxData;
     DBSFData          : ^DieBox_SF_Stn_Rec;    {S&F-Infos vom DieBox-S&F}
     FBBSFData         : ^FBB_SF_Stn_Rec;      {S&F-Infos vom FBB-S&F}
     PwData            : ^tPwData;
     {$ENDIF}
   END;


CONST
  UtcOffset      : SHORTINT	    = 0;
  EGAVGAFont     : BYTE		    = 0;
  Look_and_Feel  : BYTE		    = 0;
  Path_To_Exe    : STRING[MAX_PATH] ='';
  pMenu          : BYTE		    = 1;
  PopUp_Duration : BYTE		    = 5;
  port_anz       : BYTE		    = 0;
  mycallanz      : BYTE		    = 0;
  tfbbschans     : BYTE		    = 4;
  USE_CRT        : BOOLEAN	    = TRUE; {WriteLn statt PopUp benutzen, wird whrend InitMCUT False}
  FlexType       : BYTE		    = 0;
  TNCUText       : STRING[80]	    = 'Sorry, Terminal offline pse QRX or //Q';
  TNCDosText     : STRING[80]	    = 'DOS-Shell, please qrx';
  termecho       : BOOLEAN	    = TRUE;

CONST

   FixData:TConfigData=
   (pos_of_config_data:0;crc_von_exe:0;crc_von_ovr:0;ovr_buf_size:0;ID:'|sf7k#!"2');



   {Aktiver Kanal}
   Channel     : BYTE       = 1;
   MoniStatus  : BYTE       = 0;
   device      : BYTE       = 0; {0=TNC/TFPCX 1=PC/FlexNet}

   {Position der Elemente auf dem Bildschirm}

   pMenue      : BYTE       = 1;
   pQSOWin     : BYTE       = 2;
   pVorschreib : BYTE       = 16;
   pStatus1    : BYTE       = 15;
   pStatus2    : BYTE       = 20;
   pMoni       : BYTE       = 21;
   qsowinsize  : BYTE       = 12;
   moniwinsize : BYTE       = 4;
   pBigMoniSize: BYTE       = 2;
   bigMoniWinsize:BYTE      = 24;
   MoniBufSize : BYTE       = 10;

   BufSwapTypes:BYTE=MEM_CONV+MEM_EMS+MEM_XMS+MEM_UMB+MEM_FILE;
   MoniBufSwapTypes:BYTE=MEM_CONV+MEM_EMS+MEM_UMB;

   {Farben.... neue Defaults. ---!To Do:Monochrom defaults}
   fHelp       : BYTE       = yellow+red*16;
   fhelp2      : BYTE       = blue;
   fHelpM      : BYTE       = black+cyan*16;
   fMenuHigh   : BYTE       = red+blue*16;
   fMenuMark   : BYTE       = lightgray+black*16;
   fMenu       : BYTE       = lightgray+blue*16;
   fQsorx      : BYTE       = lightgray+black*16;
   fQsotx      : BYTE       = cyan+black*16;
   fMonhead    : BYTE       = green+black*16;
   fMondata    : BYTE       = lightgray+black*16;
   fStatusoben : BYTE       = green+blue*16;
   fVorschreib : BYTE       = lightgray+black*16;
   fStatusunten: BYTE       = green+blue*16;
   fDlgAktiv   : BYTE       = black+green*16;
   fDlgBackground : BYTE    = green+blue*16;
   fDlgInaktiv : BYTE       = blue+cyan*16;
   fDlgButton  : BYTE       = blue+cyan*16;
   fDlgTitel   : BYTE       = green+blue*16;
   fPopUp      : BYTE       = yellow+blue*16;
   pops        : WORD       = 0;     {fr debugging: anzahl der PushQueue
                                      ohne PopQueue}
   Tnc_An      : BOOLEAN    = FALSE; {TNC/FlexNet online ?}
   SerWriteDelay:BYTE       = 3;     {Verzgerung beim Schreiben auf COMx}
   ReSyncAnz   : BYTE       = 0;     {Anzahl der ReSyncs}
   PacLen      : BYTE       = 250;
   Router_TimeOut:WORD      = 300;   {hchstens 5 Minuten fr Routing}

   TNCModeText:Array[0..15] of string[3]=
      ('DIS','SET','FMR','DRQ','IXF','REJ','WAK','DBS','RBS','BBS','WDB',
       'WRB','WBB','RDB','RRB','RBB');

(****************************************************************************)
(*   Variablen und Konstanten fr TNC-Ansteuerung                           *)
(****************************************************************************)

   TncChan     : BYTE       = 10; (*anzahl der TNC Kanle*)
   baud        : LONGINT    = 19200;
   _interrupt   : BYTE       = 0;
   portaddress : WORD       = 0;
   flow_control: BYTE       = 0;
   _comport    : BYTE       = 0;
   XHOST       : BOOLEAN    = FALSE;
   multiport   : BOOLEAN    = FALSE;

(****************************************************************************)

   AllocChans  : BYTE       = 0;
   MaxTerminal : BYTE       = 10;
   Run_At_Connect : STRING[MAX_PATH]  = '';
   Run_At_Disconnect : STRING[MAX_PATH] = '';
   Beep_at_connect : BOOLEAN = TRUE;
   

   RingBell    : STRING     = '';
   DiscBell    : STRING     = '';
   ConBell     : STRING     = '220,50,0,100,220,50,0,100,220,50,0,100,440,100,0,'+
                              '100,440,200,0,100,880,100,0,100,220,400,0,100';
   Klingel     : BOOLEAN    = TRUE;
   MaxRing     : BYTE       = 5;
   MoniDecomp  : BOOLEAN    = FALSE;
   MoniTCPIP   : BOOLEAN    = TRUE;
   MoniBIN     : BOOLEAN    = FALSE;
   {Pfade...}
   QRVPath     : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'';
   BoxPath     : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'box'+PATH_SEP;
   SavPath     : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'save'+PATH_SEP;
   RemPath     : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'remote'+PATH_SEP;
   RunPath     : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'run'+PATH_SEP;
   SevenPath   : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'7plus'+PATH_SEP;
   TempPath    : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'temp'+PATH_SEP;
   textPath    : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'texte'+PATH_SEP;
   HelpPath    : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'help'+PATH_SEP;
   XPRoGPath    : STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'xprog'+PATH_SEP;

   Aktuell     : STRING[80] = '';      {fr %a in infotexten}
   ports       : BYTE       = 0;       {Anzahl der Radio-Ports}
   runswap     : BOOLEAN    = FALSE;   {swapping bei //RUN}
   dosswap     : BOOLEAN    = FALSE;   {swapping bei //DOS}
   shellswap   : BOOLEAN    = TRUE;    {swapping bei datei|dos shell}

   MCUT_Ende   : BOOLEAN    = FALSE;   {Wenn TRUE, wird MCUT beendet}
   Through_RX  : LONGINT    = 0;       {Durchsatz, whrend letzte 10s}
   Through_TX  : LONGINT    = 0;
   KBytes_RX   : LONGINT    = 0;       {Bytes, nicht KBytes (letzte 10 sek.)}
   KBytes_TX   : LONGINT    = 0;
   Last_Mess   : LONGINT    = 0;       {Letzte Berechnung von Durchsatz/Load}
   Last_Rnds   : LONGINT    = 10;
   Max_Rnds    : LONGINT    = 10;      {Hchster gemessener wert von Cnt_Rnds}
   Cnt_Rnds    : LONGINT    = 0;       {Durchlufe der Hauptschleife}
   SysLoad     : BYTE       = 0;
   Poll_Prio   : BYTE       = 2;     {prioritt fr TNC polling}
   Handle_Prio : BYTE       = 1;     {prioritt fr Handle}
   Send_Prio   : BYTE       = 1;     {prioritt fr TNC send}
   Screen_Prio : BYTE       = 3;     {prioritt von Screen Update}
   LinkList    : STRING     = '';
   BudList     : STRING     = '';      {liste von calls, durch leerzeichen getrennt,
                                       deren statusmeldungen ignoriert werden,
                                       bei pcf mit DM beantwortet werden}

   Unproto_HomeBBS:STRING[10]='';
   Unproto_PATH:STRING[70]='';
   
   JunkData4:ARRAY[0..30] OF BYTE=
   (1,34,7,175,45,1,153,37,175,43,75,147,75,85,31,34,57,13,55,43,37,113,100,
    31,75,17,72,35,40,1,66);


   cronlist      : PCronData  = NIL;
   cronanz       : BYTE       = 0;
   holdcmdmode   : BYTE       = 0;    {: in die nchste Zeile bernehmen}
   Beta_Key      : STRING[20] = '';
   Log           : BYTE       = 1;
   defaultlevel_in:BYTE     = 2;
   defaultlevel_out:BYTE    = 1;
   PromptStr     : STRING[70] = '%r>%_%c de %m (%t)>%_';
   SysLogLevel   : BYTE       = $FF; {alles loggen}
   BeepEol       : BYTE       = 0;
   keyboard_type : BYTE       = 0;
   SaveSettings  : BOOLEAN    = TRUE;
   SystemCall    : STRING10   = 'SYSTEM';
   UseBox        : BYTE       = 1; (* Box benutzen/initialisieren ? *)
   UseConv       : BYTE       = 1; (* convers " ? *)
   Box_Is_running : BOOLEAN = FALSE;
   Convers_Is_running : BOOLEAN = FALSE;
   beta_ok:BOOLEAN=FALSE;
   default_flags:LONGINT=TU_REMOTE+TU_CONNECT+TU_RECONNECT;
   {$IFDEF BCRX}
   PACSAT_RX_ON : BOOLEAN = TRUE;
   {$ENDIF}
   Installing : BYTE = 0;
   flexnet_getsabm_delay:WORD=10;
   (*
    * Konstanten fr den Monitor
    *)
   (* Bitfelder... *)
   Monitor_Chans : LONGINT = $F;
   (* Bitfeld mit den MON_-Konstanten von oben *)
   Monitor_typ   : LONGINT = $F;
   (* Hier werden die Monitordaten reingeschrieben,
      wenn MoniSaveOn=TRUE *)
   MoniSaveFileName: STRING[MAX_PATH] = PATH_SEP+'mcut'+PATH_SEP+'save'+PATH_SEP+'monitor.sav';
   (* Soviel wurde in das Monisave-file schon geschrieben *)
   MoniSaveFileSize:LONGINT = 0;
   (* Das File ist geffnet *)
   MoniSaveOn  : BOOLEAN    = FALSE;

   SaveBuffers : BOOLEAN = TRUE;
   CRTsave     : BYTE = 0;
   LastKeyPressed:LONGINT=0;
   CRTsaveAktiv:BOOLEAN=FALSE;
   TNCIniCmds  : PQueueRec =NIL;
   TNCDeiCmds  : PQueueRec =NIL;
   rxclick :BYTE=0;
   Windows95Close:BOOLEAN=FALSE;
   ClosingInProgress:BOOLEAN=FALSE;
   MCUTisIDLE:BOOLEAN=TRUE;
   CHECK_PGP_SIG:BOOLEAN=TRUE;
   SAVE_PUBLIC_KEYS:BOOLEAN=FALSE;
   Sign_MAIL:BOOLEAN=FALSE;
   PGP_USER_NAME:STRING='';
   Home_BBS:STRING[30]='';
   My_NAME:STRING[40]='';
   My_LOC:STRING[6]='';
   SpyBufSize:BYTE=6;
   PRINTING:BYTE=0;
   {$IFDEF linux}
   tfkiss_path:STRING='';
   tfkiss_flag:BYTE=0;
   {$ENDIF}
   (* Globale Scriptvariablen... *)

   Globals:PVAR=NIL;

VAR
  Scripts: ARRAY[0..255] OF pScript;
  MoniSaveFile: TEXT;
  TNCParms    : ARRAY[0..15] OF tTNCParms;
  Default_Remotes : LONGINT;
  dlgData:ARRAY[1..10] OF STRING[100];
  SaveMode   : array[0..255] OF BYTE;
  SaveFile   : array[0..255] OF ^TEXT;

  KS         : ARRAY[0..255] OF ^TKanalRec;   {dreh- und angelpunkt}
  VorSchreib   : ARRAY[0..255] OF ^TVorSchreib; {Vorschreibpuffer}
  QSOBuf       : ARRAY[0..255] OF PMBuf;        {Backscroll Puffer}
  MoniBuf      : pMBuf;                         {Monitor Puffer}
  BufSizes     : ARRAY[0..255] OF BYTE;
  MCall        : ARRAY[0..255] OF ^STRING10;    {MyCalls der Kanle}
  HotKeys      : ARRAY[1..6]   OF CHAR;         {Anfangsbuchstaben der
                                                 Men-Texte, wegen Mehr-
                                                 sprachigkeit}

  Result       : BYTE;                            {Hostmode: Typ der
                                                  Antwort des TNC}
  BoxCmds      : PCMD;                            {Kommandos fr testcommand()}
  DT           : DateTime;
  MyCall       : STRING[12];
  BoxCall      : STRING[12];
  NodeCall     : STRING[12];
  ConvCall     : STRING[12];
  parafile,
  logfile,
  syslog       : text;
  OVFChar      : Char;
  OVF          : boolean;
  head         : headrec;
  starttime    : longint;
  ERR          : INTEGER;
  ein_s        : STRING;
  DebugFile     : TEXT;
  UmlautTable:ARRAY[0..15] OF ^TUmlautTable;
  UmlautDescription:ARRAY[0..15] OF ^STRING20;
  UmlautTableAnz:BYTE;
  long:longint;


(****************************************************************************)
(* Folgende Variablen wurden der bersicht wegen aus MCUT.PAS evakuiert,    *)
(* knnen einige davon wegfallen oder nach CRON.PAS oder PACKET.PAS         *)
(* verschoben werden                                                        *)
(****************************************************************************)

VAR
    TncData       : STRING;
    PollChan,
    SendChan,
    HandleChan    : BYTE;
    l,r   : STRING;
    OldExitProc   : Pointer;

CONST
    lastping:LONGINT=0;

TYPE pREC=RECORD
        ofs,seg:WORD;
     END;


PROCEDURE PushQueue(var queue:PQueueRec;typ:byte;s:string);
PROCEDURE PopQueue(var queue:PQueueRec;var typ:byte;var s:string);
PROCEDURE PurgeQueue(var queue:PQueueRec);
PROCEDURE PutData(c:byte;data:string);
PROCEDURE PutFile(c:byte;data:string);
PROCEDURE PutBINFile(c:byte;data:string);
FUNCTION  NewKS(c:BYTE):BOOLEAN;   {Initialisiert einen Kanal Status Record}
PROCEDURE MyExitProc;
FUNCTION Version:STRING;
FUNCTION Compiled:STRING40;

IMPLEMENTATION

USES
     {$IFDEF WA8DED}
     V24DRV,
     {$ENDIF}
      mcutlib,toolbox;
PROCEDURE PushQueue(var queue:PQueueRec;typ:byte;s:string);
VAR tmp:pqueueRec;
      l:longint;
BEGIN
  inc(popS);
  tmp:=queue;
  IF queue=NIL THEN
  BEGIN
    getmem(queue,8+length(s));
    queue^.next:=NIL ;
    queue^.typ:=typ;
    queue^.data:=s;
  END ELSE
  BEGIN
    WHILE tmp^.next<>NIL DO
      tmp:=tmp^.next;
    L:=8+byte(s[0]);
    if maxavail<270 THEN
     exit;
    getmem(tmp^.next,8+byte(s[0]));
    l:=maxavail;
    tmp:=tmp^.next;
    tmp^.next:=NIL;
    tmp^.typ:=typ;
    tmp^.data:=s;
  END;
END;

PROCEDURE PopQueue(var queue:PQueueRec;var typ:byte;var s:string);
var tmp:PqueueRec;
      l:longint;
BEGIN
  dec(pops);
  IF queue=NIL THEN
  BEGIN
    s:='';
    typ:=255;
    exit;
  END ELSE
  BEGIN
    tmp:=queue;
    s:=tmp^.data;
    typ:=tmp^.typ;
    queue:=queue^.next;
    freemem(tmp,8+length(s));
  END;
END;

PROCEDURE PutData(c:byte;data:string);
VAR len    : BYTE;
BEGIN
  IF (KS[c]=NIL) OR (data='')  Then EXIT;
  len:=Length(KS[c]^.SendRest);
  KS[c]^.SendRest:=KS[c]^.SendRest+copy(data,1,255-len);
  Delete(data,1,255-len);
  WHILE (word(LENGTH(KS[c]^.SendRest))+word(LENGTH(data))>word(KS[c]^.Paclen)) DO
  BEGIN
    ein_s:=Copy(KS[c]^.SendRest,1,KS[c]^.Paclen);
    PushQueue(KS[c]^.sendqueue,0,ein_s);
    IF (KS[c]^.FLAGS AND KS_CRONTASK)=0 THEN
    KS[c]^.TxW:=KS[c]^.TxW+BYTE(ein_s[0]);
    Delete(KS[c]^.SendRest,1,KS[c]^.PacLen);
    IF Data[0]>#0 THEN
    BEGIN
      len:=Length(KS[c]^.SendRest);
      KS[c]^.SendRest:=KS[c]^.SendRest+copy(data,1,255-len);
      Delete(data,1,255-len);
    END;
  END;
END;

PROCEDURE PutFile(c:byte;data:string);
BEGIN
  IF KS[c]=NIL Then EXIT;
  IF (KS[c]^.FLAGS AND KS_CRONTASK)=0 THEN
  KS[c]^.TxW:=KS[c]^.TxW+BYTE(Data[0]);
  IF LENGTH(KS[c]^.SendRest)>0 THEN
  BEGIN
    PushQueue(KS[c]^.SendQueue,0,KS[c]^.SendRest);
    KS[c]^.SendRest:='';
  END;
  PushQueue(KS[c]^.sendqueue,1,data);
END;

PROCEDURE PutBINFile(c:byte;data:string);
BEGIN
  IF KS[c]=NIL Then EXIT;
  IF (KS[c]^.FLAGS AND KS_CRONTASK)=0 THEN
  KS[c]^.TxW:=KS[c]^.TxW+BYTE(Data[0]);
  IF LENGTH(KS[c]^.SendRest)>0 THEN
  BEGIN
    PushQueue(KS[c]^.SendQueue,0,KS[c]^.SendRest);
    KS[c]^.SendRest:='';
  END;
  PushQueue(KS[c]^.sendqueue,2,data);
END;



FUNCTION NewKS(c:BYTE):BOOLEAN;
BEGIN
  IF KS[c]<> NIL THEN
  BEGIN
    NewKS:=TRUE;
    Exit;
  END;
  IF (MaxAvail>SizeOf(TKanalRec)) THEN
  BEGIN
    New(KS[c]);
    NewKS:=TRUE;
    FILLCHAR(KS[c]^,SizeOf(TKanalRec),0);
    KS[c]^.Paclen:=PacLen;
    KS[c]^.rempath:=rempath;
    With KS[c]^ DO
    BEGIN
      Create:=CurrIxTime;
      IdleSince:=Create;
      MaxFrame:=6;
      FLAGS := FLAGS OR KS_RECEIVEREADY;
      FLAGS := FLAGS OR KS_LINEMODE;
      FLAGS := FLAGS OR KS_AUTOSAVE;
      FLAGS := FLAGS OR KS_SHOWDATA;
      FLAGS := FLAGS OR KS_CONNECT;
      FLAGS := FLAGS OR KS_RECONNECT;
    END;
  END ELSE
    NewKS:=FALSE;
END;

PROCEDURE PurgeQueue(var queue:PQueueRec);
var TMP:PQueueRec;
BEGIN
  TMP:=Queue;
  WHILE tmp<>NIL DO
  BEGIN
    TMP:=TMP^.next;
    freemem(queue,8+Length(queue^.data));
    Queue:=TMP;

  END;
END;


(***************************************************************************)
(*   MyExitProc wird von TP beim Beenden des Programmes aufgerufen         *)
(*   Sie schreibt evtl RunErrors nach DEBUG.MCT, gibt den Speicher der     *)
(*   QSOBuffer frei und restauriert den Interupthandler fr COMx           *)
(***************************************************************************)
{$S-,R-,I-}

PROCEDURE MyExitProc; {wird auch bei runerror etc aufgerufen}
VAR B:BYTE; x:POINTER;y:INTEGER;
BEGIN
   exitproc:=oldexitproc;
{$IFNDEF LINUX}
   {$S-,R-,I-}
  X:=erroraddr;
  Y:=exitcode;
  ExitProc:=oldexitproc;
  InOutRes:=0;
  IF X<>NIL THEN
    WriteLN('RE#',Y,'@',xhex(pREC(X).seg),':',xhex(pREC(X).ofs));
  InOutRes:=0;
  IF X<>NIL THEN
  BEGIN
    WriteLn(DebugFile,'RE#',Y:3,'@',xhex(pREC(X).seg),':',xhex(pREC(X).ofs));
    InOutRes:=0;
    close(debugfile);
  END;
  FOR B:=1 to AllocChans DO Dispose(QSObuf[b],done);
  IF monibuf<>NIL THEN
    dispose(monibuf,done);
  {$IFDEF WA8DED}
  IF device=1 THEN
    V24Close;
  {$ENDIF}
   {$ENDIF}
END;
{$S+,R+,I+}

FUNCTION Version:STRING;
BEGIN
  VERSION:='1.08';
END;



FUNCTION CS:STRING40;
CONST
   {$I compiled.inc}
BEGIN
  CS:=compiled;
END;

FUNCTION Compiled:STRING40;
BEGIN
  compiled:=cs;
END;

BEGIN
END.
