(****************************************************************************)
(* Ausfiltern einzelner QSO aus dem Monitor-Datestrom                       *)
(* Diese Unit sollte nicht als Overlay deklariert werden                    *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(****************************************************************************)

UNIT SPY;
INTERFACE

USES IADVAR;
TYPE SpyProc=FUNCTION(id:BYTE;var data:STRING):BYTE;

  PROCEDURE Flush(asource,adest:STRING10);
  FUNCTION InitSpy(asource,adest:STRING10;ahandler:SpyProc):WORD;
  PROCEDURE HandleSpy(source,dest:STRING10;nr,ns:BYTE;len:WORD;var data);
  PROCEDURE HandleSpyControl(source,dest:STRING;nr,ns,typ:BYTE);

IMPLEMENTATION

TYPE
  maxtext:ARRAY[1..300] OF BYTE;
  mtextrec=RECORD
    len:WORD;
    text:maxtext;
  END;
  pSpy=^tSpy;
  tSpy=RECORD;
    id:WORD;
    source,dest:STRING10;
    nextr,status,sammlerstart,sammlerend:BYTE;
    restline:STRING;
    framesammler:ARRAY[0..7] OF ^MTextRec;
    handler:SpyProc;
    NEXT:pSpy;
  END;

CONST
  spyroot:pSpy=NIL;
  NextID:WORD=1;

FUNCTION InitSpy;
VAR aSpy:pSpy;
BEGIN
  InitSpy:=0;
  IF maxavail<10000 THEN
    exit;
  IF SpyRoot=NIL THEN
  BEGIN
    new(spyroot);
    aSpy:=SpyRoot;
  END ELSE
  BEGIN
    aSpy:=SpyRoot;
    WHILE aSpy^.Next<>NIL DO
      aSpy:=aSpy^.Next;
    NEW(aSpy^.Next);
    aSpy:=aSpy^.Next;
  END;
  fillchar(aSpy^,SizeOf(tSpy),0);
  WITH aSpy^ DO
  BEGIN
    id:=NextID;
    INC(NextID);
    dest:=adest;
    source:=aSource;
    handler:=aHandler;
    status=0;
    InitSpy:=ID;
  END;
END;


PROCEDURE HandleSpy;
VAR aSpy:pSpy; W:WORD;
BEGIN
  aSpy:=SpyRoot;
  WHILE aSpy<>NIL DO
  BEGIN
    WITH aSpy^ DO
    BEGIN
      IF (source=asource) AND (dest=adest) THEN
      BEGIN
        IF nextr=nr THEN
        BEGIN
          FOR W:=1 To len DO
          BEGIN
            INC(RestLine[0]);
            RestLine[length(restline)]:=MaxText(data)[W];
            IF (RestLine[length(restLine]=#13) OR
               (RestLine[length(restLine]=#10) OR
               (length(restline)=255) THEN
            BEGIN
              Handler(id,RestLine);
              RestLine:='';
            END;
          END;
        END;
      END;
    END;
  END;
END;

END;